# coding: utf-8
import requests
import json
import psycopg2
import uuid
import datetime  
import time
import hashlib  
import time

#全局变量，便于参数使用的预设值 
current_date = datetime.date.today()     # 获取当前日期 
previous_date = current_date - datetime.timedelta(days=1)  # 获取前一天日期 
formatted_current_date = current_date.strftime("%Y-%m-%dT%H:%M:%SZ")  # 获取当前日期 - 标准化
formatted_previous_date = previous_date.strftime("%Y-%m-%dT%H:%M:%SZ")  # 获取前一天日期 - 标准化
timestamp = time.time()       #  为Unix time，即从"1970-01-01 00:00:00"至今的秒数；
sign_version = 'v2'     # 签名版本号，固定值v2
nonce = str(uuid.uuid4())

#获取签名令牌
def sign_data(email, open_api_token, timestamp, nonce, sign_version):  
    # 按照指定的格式拼接字符串  
    data_to_sign = f"{email}&{open_api_token}&{timestamp}&{nonce}&{sign_version}"  
    # 使用SHA256算法计算哈希值  
    sha256_hash = hashlib.sha256(data_to_sign.encode()).hexdigest()  
    return sha256_hash  

#获取鉴权token
def get_token(url):
    #请求鉴权接口
    authRequest=requests.get(url)
    #解析结果
    if not authRequest:       #若为空时，返回空
        return
    auth=json.loads(authRequest.text)
    return auth

print('开始加载数据：update_scrm_contact:更新scrm CONTACT')
authUrl='https://api.huiju.cool/v2/oauth2/token?app_id=cl037b184ebccd97c&secret=deaa83fdd8d385eec0d1d04d34282c4ec8c33b60&grant_type=client_credentials'
 
print('开始请求令牌。')
#authRequest=requests.get(authUrl)
#auth=json.loads(authRequest.text)
auth = get_token(authUrl)
#循环判断auth是否为空，若为空，等待30s后重新请求
i = 0
while not auth['access_token'] and i < 60:
    time.sleep(60)
    auth = get_token(authUrl)
    i = i + 1
print('开始请求数据总数。')
url='https://api.huiju.cool/v2/customers'
header={}
body={'access_token':auth['access_token'],'limit':'2000','sort':'lastUpdated','lastUpdated[le]':formatted_current_date,'lastUpdated[ge]':formatted_previous_date,}
dataReqL=requests.get(url,headers=header,params=body)
resL=json.loads(dataReqL.text)
# print(resL)
dataList=resL['data']
total=len(dataList)
conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",
                                host="172.17.0.8", port="5432")
print('数据库连接成功')
dataId=str(uuid.uuid4())
print('临时id：'+dataId)
json_object = json.dumps(dataList)
cur=conn.cursor()
sql="update data_api.api_data set is_loaded = '1' where api_id = '03d918ea-00d1-448a-8b9b-6a0b1a33';INSERT INTO data_api.api_data (id,api_id,data,total_num,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
cur.execute(sql,[dataId,'03d918ea-00d1-448a-8b9b-6a0b1a33',json_object,total])
conn.commit()
cur.close()
conn.close()
print('加载数据结束：update_scrm_contact:更新scrm CONTACT')