/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_scrm_leads(SCRM线索)             */
/*Create Date:2024-04-18 16:32:47                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-04-18                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-04-18                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_custom_events_activity_submit                                       */
/*Source table 2: p10_sa.s98_s_customer_events_open_app                                            */
/*Source table 3: p10_sa.s98_s_customer_events_submit_form                                         */
/*Source table 4: p10_sa.s98_s_customer_events_open_page                                           */
/*Source table 5: p10_sa.s98_s_customer_events_subscribe                                           */
/*Source table 6: p10_sa.s98_s_customer_events_add_user                                            */
/*Source table 7: p10_sa.s98_s_customer_events_c_minipro_page_view                                 */
/*Source table 8: :SADB.select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta*/
/*Source table 9: p10_sa.s98_s_customer_events_open_content_page                                   */
/*Source table 10: p10_sa.s98_s_customer_events_wechat_scan                                         */
/*Source table 11: p10_sa.s98_s_customer_events_click_link_in_page                                  */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_scrm_leads                                                                      */
/*ETL Job Name:t01_scrm_leads                                                                      */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_leads_agi_CUR_I 
 ( LIKE :PDMDB.t01_scrm_leads)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_leads_agi_INS 
( LIKE :PDMDB.t01_scrm_leads)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_customer_events_open_app************************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_open_app',1,3)              /*src_sysname*/
        ,'s98_s_customer_events_open_app'                          /*src_table*/
        
FROM p10_sa.s98_s_customer_events_open_app  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 2:Source Table:s98_s_custom_events_activity_submit*******************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,COALESCE(TRIM(CAST(p0.content_name AS VARCHAR(30))),'')        /*content_name*/
        ,COALESCE(TRIM(CAST(p0.source AS VARCHAR(50))),'')         /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_custom_events_activity_submit',1,3)         /*src_sysname*/
        ,'s98_s_custom_events_activity_submit'                     /*src_table*/
        
FROM p10_sa.s98_s_custom_events_activity_submit  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 3:Source Table:s98_s_customer_events_open_page***********************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_open_page',1,3)             /*src_sysname*/
        ,'s98_s_customer_events_open_page'                         /*src_table*/
        
FROM p10_sa.s98_s_customer_events_open_page  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 4:Source Table:s98_s_customer_events_open_content_page***************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_open_content_page',1,3)        /*src_sysname*/
        ,'s98_s_customer_events_open_content_page'                 /*src_table*/
        
FROM p10_sa.s98_s_customer_events_open_content_page  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 5:Source Table:s98_s_customer_events_subscribe***********************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_subscribe',1,3)             /*src_sysname*/
        ,'s98_s_customer_events_subscribe'                         /*src_table*/
        
FROM p10_sa.s98_s_customer_events_subscribe  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 6:Source Table:s98_s_customer_events_c_minipro_page_view*************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,COALESCE(TRIM(CAST(p0.c_name AS VARCHAR(30))),'')         /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_c_minipro_page_view',1,3)        /*src_sysname*/
        ,'s98_s_customer_events_c_minipro_page_view'               /*src_table*/
        
FROM p10_sa.s98_s_customer_events_c_minipro_page_view  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 7:Source Table:s98_s_customer_events_submit_form*********************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_submit_form',1,3)           /*src_sysname*/
        ,'s98_s_customer_events_submit_form'                       /*src_table*/
        
FROM p10_sa.s98_s_customer_events_submit_form  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 8:Source Table:s98_s_customer_events_add_user************************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,''                                                        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,COALESCE(TRIM(CAST(p0.source AS VARCHAR(50))),'')         /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,COALESCE(TRIM(CAST(p0.attr2 AS VARCHAR(30))),'')          /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_add_user',1,3)              /*src_sysname*/
        ,'s98_s_customer_events_add_user'                          /*src_table*/
        
FROM p10_sa.s98_s_customer_events_add_user  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 9:Source Table:s98_s_customer_events_click_link_in_page**************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_click_link_in_page',1,3)        /*src_sysname*/
        ,'s98_s_customer_events_click_link_in_page'                /*src_table*/
        
FROM p10_sa.s98_s_customer_events_click_link_in_page  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*****************************************************************************************************/
/* GROUP 10:Source Table:s98_s_customer_events_wechat_scan*********************************************/
/*****************************************************************************************************/
INSERT INTO t01_scrm_leads_agi_CUR_I (
            customer_id                             /*customerId*/
           ,date                                    /*date*/
           ,target_name                             /*targetName*/
           ,c_name                                  /*c_name*/
           ,c_type                                  /*c_type*/
           ,content_name                            /*contentName*/
           ,source                                  /*source*/
           ,tag                                     /*tag*/
           ,c_keyword                               /*c_keyword*/
           ,attr2                                   /*attr2*/
           ,label                                   /*label*/
           ,group_label                             /*groupLabel*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.customer_id AS VARCHAR(30))),'')        /*customer_id*/
        ,COALESCE(p0."date"::timestamp(0),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*date*/
        ,COALESCE(TRIM(CAST(p0.target_name AS VARCHAR(30))),'')        /*target_name*/
        ,''                                                        /*c_name*/
        ,''                                                        /*c_type*/
        ,''                                                        /*content_name*/
        ,''                                                        /*source*/
        ,''                                                        /*tag*/
        ,''                                                        /*c_keyword*/
        ,''                                                        /*attr2*/
        ,coalesce(p1.events_label,'')                              /*label*/
        ,coalesce(p1.group_label,'')                               /*group_label*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_customer_events_wechat_scan',1,3)           /*src_sysname*/
        ,'s98_s_customer_events_wechat_scan'                       /*src_table*/
        
FROM p10_sa.s98_s_customer_events_wechat_scan  p0
LEFT JOIN (select group_name ,group_label ,json_array_elements(events::json)->> 'name'::text as events_name,json_array_elements(events::json)->> 'label'::text as events_label
from :SADB.s98_s_customer_event_meta) p1
        ON p0.event=p1.events_name
;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_scrm_leads_agi_INS (
         target_name                                               /*targetName*/
        ,c_name                                                    /*c_name*/
        ,c_type                                                    /*c_type*/
        ,content_name                                              /*contentName*/
        ,source                                                    /*source*/
        ,tag                                                       /*tag*/
        ,c_keyword                                                 /*c_keyword*/
        ,attr2                                                     /*attr2*/
        ,group_label                                               /*groupLabel*/
        ,customer_id                                               /*customerId*/
        ,date                                                      /*date*/
        ,label                                                     /*label*/
        ,etl_batch_no                                              /*作业批次号*/
        ,etl_first_dt                                              /*最初入库时间*/
        ,etl_job                                                   /*作业名称*/
        ,etl_proc_dt                                               /*本次入库时间*/
        ,etl_tx_dt                                                 /*作业运行时间*/
        ,src_sysname                                               /*来源系统*/
        ,src_table                                                 /*来源表*/
        
)
    SELECT
         P1.target_name                                               /*targetName*/
        ,P1.c_name                                                    /*c_name*/
        ,P1.c_type                                                    /*c_type*/
        ,P1.content_name                                              /*contentName*/
        ,P1.source                                                    /*source*/
        ,P1.tag                                                       /*tag*/
        ,P1.c_keyword                                                 /*c_keyword*/
        ,P1.attr2                                                     /*attr2*/
        ,P1.group_label                                               /*groupLabel*/
        ,P1.customer_id                                               /*customerId*/
        ,P1.date                                                      /*date*/
        ,P1.label                                                     /*label*/
        ,P1.etl_batch_no                                              /*作业批次号*/
        ,P1.etl_first_dt                                              /*最初入库时间*/
        ,P1.etl_job                                                   /*作业名称*/
        ,P1.etl_proc_dt                                               /*本次入库时间*/
        ,P1.etl_tx_dt                                                 /*作业运行时间*/
        ,P1.src_sysname                                               /*来源系统*/
        ,P1.src_table                                                 /*来源表*/
        
FROM t01_scrm_leads_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_scrm_leads P2
ON    P1.target_name = P2.target_name
    AND P1.c_name = P2.c_name
    AND P1.c_type = P2.c_type
    AND P1.content_name = P2.content_name
    AND P1.source = P2.source
    AND P1.tag = P2.tag
    AND P1.c_keyword = P2.c_keyword
    AND P1.attr2 = P2.attr2
    AND P1.group_label = P2.group_label
    AND P1.customer_id = P2.customer_id
    AND P1.date = P2.date
    AND P1.label = P2.label
    
WHERE  P2.target_name IS NULL
    OR P2.c_name IS NULL
    OR P2.c_type IS NULL
    OR P2.content_name IS NULL
    OR P2.source IS NULL
    OR P2.tag IS NULL
    OR P2.c_keyword IS NULL
    OR P2.attr2 IS NULL
    OR P2.group_label IS NULL
    OR P2.customer_id IS NULL
    OR P2.date IS NULL
    OR P2.label IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_scrm_leads (
         target_name                                               /*targetName*/
        ,c_name                                                    /*c_name*/
        ,c_type                                                    /*c_type*/
        ,content_name                                              /*contentName*/
        ,source                                                    /*source*/
        ,tag                                                       /*tag*/
        ,c_keyword                                                 /*c_keyword*/
        ,attr2                                                     /*attr2*/
        ,group_label                                               /*groupLabel*/
        ,customer_id                                               /*customerId*/
        ,date                                                      /*date*/
        ,label                                                     /*label*/
        ,etl_batch_no                                              /*作业批次号*/
        ,etl_first_dt                                              /*最初入库时间*/
        ,etl_job                                                   /*作业名称*/
        ,etl_proc_dt                                               /*本次入库时间*/
        ,etl_tx_dt                                                 /*作业运行时间*/
        ,src_sysname                                               /*来源系统*/
        ,src_table                                                 /*来源表*/
        
)
SELECT
         P1.target_name                                               /*targetName*/
        ,P1.c_name                                                    /*c_name*/
        ,P1.c_type                                                    /*c_type*/
        ,P1.content_name                                              /*contentName*/
        ,P1.source                                                    /*source*/
        ,P1.tag                                                       /*tag*/
        ,P1.c_keyword                                                 /*c_keyword*/
        ,P1.attr2                                                     /*attr2*/
        ,P1.group_label                                               /*groupLabel*/
        ,P1.customer_id                                               /*customerId*/
        ,P1.date                                                      /*date*/
        ,P1.label                                                     /*label*/
        ,P1.etl_batch_no                                              /*作业批次号*/
        ,P1.etl_first_dt                                              /*最初入库时间*/
        ,P1.etl_job                                                   /*作业名称*/
        ,P1.etl_proc_dt                                               /*本次入库时间*/
        ,P1.etl_tx_dt                                                 /*作业运行时间*/
        ,P1.src_sysname                                               /*来源系统*/
        ,P1.src_table                                                 /*来源表*/
        
FROM t01_scrm_leads_agi_INS P1
ON CONFLICT ( customer_id,date,label)
DO UPDATE SET
     customer_id=excluded.customer_id
    ,date=excluded.date
    ,label=excluded.label
    ,target_name=excluded.target_name
    ,c_name=excluded.c_name
    ,c_type=excluded.c_type
    ,content_name=excluded.content_name
    ,source=excluded.source
    ,tag=excluded.tag
    ,c_keyword=excluded.c_keyword
    ,attr2=excluded.attr2
    ,group_label=excluded.group_label
    ,etl_batch_no=excluded.etl_batch_no
    ,etl_first_dt=excluded.etl_first_dt
    ,etl_job=excluded.etl_job
    ,etl_proc_dt=excluded.etl_proc_dt
    ,etl_tx_dt=excluded.etl_tx_dt
    ,src_sysname=excluded.src_sysname
    ,src_table=excluded.src_table
    

;
/*****程序结束退出                                               */
\q

