
DROP TABLE IF EXISTS p20_pdm.t01_scrm_contact_merge;
CREATE TABLE IF NOT EXISTS p20_pdm.t01_scrm_contact_merge (
	 merged_leads_id  VARCHAR(30) 
	, scrm_leads_id  VARCHAR(30) 
	, proc_date  timestamp(0) 
	, event  VARCHAR(30) 
	, target_name  VARCHAR(30) 
	, last_updated  timestamp(0) 
	, name  VARCHAR(30) 
	, type  VARCHAR(30) 
	, content_name  VARCHAR(30) 
	, source  VARCHAR(30) 
	, tag  VARCHAR(30) 
	, keyword  VARCHAR(30) 
	, attr  VARCHAR(30) 
	, group_label  VARCHAR(30) 
	, label  VARCHAR(30) 
	, etl_batch_no  VARCHAR(50) 
	, etl_first_dt  timestamp(0) 
	, etl_job  VARCHAR(50) 
	, etl_proc_dt  timestamp(0) 
	, etl_tx_dt  timestamp(0) 
	, src_sysname  VARCHAR(50) 
	, src_table  VARCHAR(50) 
	,primary key( merged_leads_id,scrm_leads_id )
);

 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.merged_leads_id IS '被合并线索ID'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.scrm_leads_id IS '线索ID'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.proc_date IS '处理日期'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.event IS '处理事项'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.target_name IS '目标名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.last_updated IS '最后更新日期'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.name IS '名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.type IS '类型'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.content_name IS '目录名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.source IS '来源'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.tag IS '客户标签'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.keyword IS '关键词'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.attr IS '属性'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.group_label IS '标签组'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.label IS '标签'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.etl_batch_no IS '作业批次号'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.etl_first_dt IS '最初入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.etl_job IS '作业名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.etl_proc_dt IS '本次入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.etl_tx_dt IS '作业运行时间'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.src_sysname IS '来源系统'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.src_table IS '来源表'; 

COMMENT ON TABLE p20_pdm.t01_scrm_contact_merge IS 'SCRM联系方式合并';