/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :T01_CRM_CCP_TYPE(CRM_CCP分类)             */
/*Create Date:2024-01-15 20:10:56                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-01-11                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-01-15                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_ccp_mapping_table                                                   */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:T01_CRM_CCP_TYPE                                                                    */
/*ETL Job Name:T01_CRM_CCP_TYPE                                                                    */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE T01_CRM_CCP_TYPE_agi_CUR_I 
 ( LIKE :PDMDB.T01_CRM_CCP_TYPE)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE T01_CRM_CCP_TYPE_agi_INS 
( LIKE :PDMDB.T01_CRM_CCP_TYPE)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_ccp_mapping_table*******************************************************/
/*****************************************************************************************************/
INSERT INTO T01_CRM_CCP_TYPE_agi_CUR_I (
            ccp_id                                  /*CCP编号*/
           ,ccp_value                               /*CCP值*/
           ,ccp_type                                /*CCP类型*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.ccp_id AS varchar(50))),'')         /*ccp_id*/
        ,COALESCE(TRIM(CAST(p0.ccp_value AS varchar(100))),'')        /*ccp_value*/
        ,COALESCE(TRIM(CAST(p0.ccp_type AS varchar(30))),'')        /*ccp_type*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_ccp_mapping_table',1,3)                     /*Src_Sysname*/
        ,'s98_s_ccp_mapping_table'                                 /*Src_Table*/
        
FROM p10_sa.s98_s_ccp_mapping_table  p0
;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO T01_CRM_CCP_TYPE_agi_INS (
         ccp_value                                                 /*CCP值*/
        ,ccp_type                                                  /*CCP类型*/
        ,ccp_id                                                    /*CCP编号*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.ccp_value                                                 /*CCP值*/
        ,P1.ccp_type                                                  /*CCP类型*/
        ,P1.ccp_id                                                    /*CCP编号*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM T01_CRM_CCP_TYPE_agi_CUR_I P1
LEFT JOIN :PDMDB.T01_CRM_CCP_TYPE P2
ON    P1.ccp_value = P2.ccp_value
    AND P1.ccp_type = P2.ccp_type
    AND P1.ccp_id = P2.ccp_id
    
WHERE  P2.ccp_value IS NULL
    OR P2.ccp_type IS NULL
    OR P2.ccp_id IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.T01_CRM_CCP_TYPE (
         ccp_value                                                 /*CCP值*/
        ,ccp_type                                                  /*CCP类型*/
        ,ccp_id                                                    /*CCP编号*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.ccp_value                                                 /*CCP值*/
        ,P1.ccp_type                                                  /*CCP类型*/
        ,P1.ccp_id                                                    /*CCP编号*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM T01_CRM_CCP_TYPE_agi_INS P1
ON CONFLICT ( ccp_id)
DO UPDATE SET
     ccp_id=excluded.ccp_id
    ,ccp_value=excluded.ccp_value
    ,ccp_type=excluded.ccp_type
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

