/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_crm_cust_ccp(CRM客户CCP)             */
/*Create Date:2024-01-15 20:17:01                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-01-15                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-01-15                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_crm_contact_ccp                                                     */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_crm_cust_ccp                                                                    */
/*ETL Job Name:t01_crm_cust_ccp                                                                    */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_cust_ccp_agi_CUR_I 
 ( LIKE :PDMDB.t01_crm_cust_ccp)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_cust_ccp_agi_INS 
( LIKE :PDMDB.t01_crm_cust_ccp)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_crm_contact_ccp*********************************************************/
/*****************************************************************************************************/
INSERT INTO t01_crm_cust_ccp_agi_CUR_I (
            crm_contact_account                     /*CRM_CONTACT账号*/
           ,create_time                             /*创建时间*/
           ,ccp_value                               /*ccp值*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.tek_contactnumber AS varchar(20))),'')        /*crm_contact_account*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.newcreation AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*create_time*/
        ,COALESCE(TRIM(CAST(p0.tek_ccpchoiceidname AS varchar(50))),'')        /*ccp_value*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_crm_contact_ccp',1,3)                       /*Src_Sysname*/
        ,'s98_s_crm_contact_ccp'                                   /*Src_Table*/
        
FROM p10_sa.s98_s_crm_contact_ccp  p0
;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_crm_cust_ccp_agi_INS (
         create_time                                               /*创建时间*/
        ,crm_contact_account                                       /*CRM_CONTACT账号*/
        ,ccp_value                                                 /*ccp值*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.create_time                                               /*创建时间*/
        ,P1.crm_contact_account                                       /*CRM_CONTACT账号*/
        ,P1.ccp_value                                                 /*ccp值*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_crm_cust_ccp_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_crm_cust_ccp P2
ON    P1.create_time = P2.create_time
    AND P1.crm_contact_account = P2.crm_contact_account
    AND P1.ccp_value = P2.ccp_value
    
WHERE  P2.create_time IS NULL
    OR P2.crm_contact_account IS NULL
    OR P2.ccp_value IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_crm_cust_ccp (
         create_time                                               /*创建时间*/
        ,crm_contact_account                                       /*CRM_CONTACT账号*/
        ,ccp_value                                                 /*ccp值*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.create_time                                               /*创建时间*/
        ,P1.crm_contact_account                                       /*CRM_CONTACT账号*/
        ,P1.ccp_value                                                 /*ccp值*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_crm_cust_ccp_agi_INS P1
ON CONFLICT ( crm_contact_account,ccp_value)
DO UPDATE SET
     crm_contact_account=excluded.crm_contact_account
    ,ccp_value=excluded.ccp_value
    ,create_time=excluded.create_time
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

