/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_crm_account(CRM客户账号)             */
/*Create Date:2024-01-11 16:00:06                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-01-11                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-01-11                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_crm_account                                                         */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_crm_account                                                                     */
/*ETL Job Name:t01_crm_account                                                                     */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_account_agi_CUR_I 
 ( LIKE :PDMDB.t01_crm_account)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_account_agi_INS 
( LIKE :PDMDB.t01_crm_account)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_crm_account*************************************************************/
/*****************************************************************************************************/
INSERT INTO t01_crm_account_agi_CUR_I (
            accountnumber                           /*accountnumber*/
           ,name                                    /*name*/
           ,tek_channelidname                       /*tek_channelidname*/
           ,address1_city                           /*address1_city*/
           ,tek_address1_stateidname                /*tek_address1_stateidname*/
           ,tek_address1_countryidname              /*tek_address1_countryidname*/
           ,address1_line1                          /*address1_line1*/
           ,address1_postalcode                     /*address1_postalcode*/
           ,tek_accountterritoryidname              /*tek_accountterritoryidname*/
           ,statecodename                           /*statecodename*/
           ,tek_omarcustomercode                    /*tek_omarcustomercode*/
           ,tek_erpsitenumber                       /*tek_erpsitenumber*/
           ,tek_newcountofactivecontacts            /*tek_newcountofactivecontacts*/
           ,tek_countofcases                        /*tek_countofcases*/
           ,tek_countofleads                        /*tek_countofleads*/
           ,tek_countofopportunities                /*tek_countofopportunities*/
           ,tek_countofnamedaccount                 /*tek_countofnamedaccount*/
           ,createdbyname                           /*createdbyname*/
           ,createdon                               /*createdon*/
           ,tek_3yearvalue                          /*tek_3yearvalue*/
           ,tek_3yrordertotal                       /*tek_3yrordertotal*/
           ,customertypecodename                    /*customertypecodename*/
           ,adx_activeopportunitycount              /*adx_activeopportunitycount*/
           ,donotbulkemail                          /*donotbulkemail*/
           ,donotbulkpostalmail                     /*donotbulkpostalmail*/
           ,donotemail                              /*donotemail*/
           ,donotfax                                /*donotfax*/
           ,donotpostalmail                         /*donotpostalmail*/
           ,donotphone                              /*donotphone*/
           ,ftv_dqphoneclean                        /*ftv_dqphoneclean*/
           ,tek_op_duplicatestatusname              /*tek_op_duplicatestatusname*/
           ,tek_plussetupcompletedname              /*tek_plussetupcompletedname*/
           ,tek_customeridname                      /*tek_customeridname*/
           ,tek_industryidname                      /*tek_industryidname*/
           ,tek_mkto_channel                        /*tek_mkto_channel*/
           ,tek_mkto_region                         /*tek_mkto_region*/
           ,modifiedbyname                          /*modifiedbyname*/
           ,modifiedon                              /*modifiedon*/
           ,owneridname                             /*owneridname*/
           ,parentaccountidname                     /*parentaccountidname*/
           ,Scd_Start_Dt                            /*开始时间*/
           ,Scd_End_Dt                              /*结束时间*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(p0.accountnumber),'')                       /*accountnumber*/
        ,COALESCE(TRIM(p0.name),'')                                /*name*/
        ,COALESCE(TRIM(p0.tek_channelidname),'')                   /*tek_channelidname*/
        ,COALESCE(TRIM(p0.address1_city),'')                       /*address1_city*/
        ,COALESCE(TRIM(p0.tek_address1_stateidname),'')            /*tek_address1_stateidname*/
        ,COALESCE(TRIM(p0.tek_address1_countryidname),'')          /*tek_address1_countryidname*/
        ,COALESCE(TRIM(p0.address1_line1),'')                      /*address1_line1*/
        ,COALESCE(TRIM(p0.address1_postalcode),'')                 /*address1_postalcode*/
        ,COALESCE(TRIM(p0.tek_accountterritoryidname),'')          /*tek_accountterritoryidname*/
        ,COALESCE(TRIM(p0.statecodename),'')                       /*statecodename*/
        ,COALESCE(TRIM(p0.tek_omarcustomercode),'')                /*tek_omarcustomercode*/
        ,COALESCE(TRIM(p0.tek_erpsitenumber),'')                   /*tek_erpsitenumber*/
        ,COALESCE(TRIM(p0.tek_newcountofactivecontacts),'')        /*tek_newcountofactivecontacts*/
        ,COALESCE(TRIM(p0.tek_countofcases),'')                    /*tek_countofcases*/
        ,COALESCE(TRIM(p0.tek_countofleads),'')                    /*tek_countofleads*/
        ,COALESCE(TRIM(p0.tek_countofopportunities),'')            /*tek_countofopportunities*/
        ,COALESCE(TRIM(p0.tek_countofnamedaccount),'')             /*tek_countofnamedaccount*/
        ,COALESCE(TRIM(p0.createdbyname),'')                       /*createdbyname*/
        ,COALESCE(TRIM(p0.createdon),'')                           /*createdon*/
        ,COALESCE(TRIM(p0.tek_3yearvalue),'')                      /*tek_3yearvalue*/
        ,COALESCE(TRIM(p0.tek_3yrordertotal),'')                   /*tek_3yrordertotal*/
        ,COALESCE(TRIM(p0.customertypecodename),'')                /*customertypecodename*/
        ,COALESCE(TRIM(p0.adx_activeopportunitycount),'')          /*adx_activeopportunitycount*/
        ,COALESCE(TRIM(p0.donotbulkemail),'')                      /*donotbulkemail*/
        ,COALESCE(TRIM(p0.donotbulkpostalmail),'')                 /*donotbulkpostalmail*/
        ,COALESCE(TRIM(p0.donotemail),'')                          /*donotemail*/
        ,COALESCE(TRIM(p0.donotfax),'')                            /*donotfax*/
        ,COALESCE(TRIM(p0.donotpostalmail),'')                     /*donotpostalmail*/
        ,COALESCE(TRIM(p0.donotphone),'')                          /*donotphone*/
        ,COALESCE(TRIM(p0.ftv_dqphoneclean),'')                    /*ftv_dqphoneclean*/
        ,COALESCE(TRIM(p0.tek_op_duplicatestatusname),'')          /*tek_op_duplicatestatusname*/
        ,COALESCE(TRIM(p0.tek_plussetupcompletedname),'')          /*tek_plussetupcompletedname*/
        ,COALESCE(TRIM(p0.tek_customeridname),'')                  /*tek_customeridname*/
        ,COALESCE(TRIM(p0.tek_industryidname),'')                  /*tek_industryidname*/
        ,COALESCE(TRIM(p0.tek_mkto_channel),'')                    /*tek_mkto_channel*/
        ,COALESCE(TRIM(p0.tek_mkto_region),'')                     /*tek_mkto_region*/
        ,COALESCE(TRIM(p0.modifiedbyname),'')                      /*modifiedbyname*/
        ,COALESCE(TRIM(p0.modifiedon),'')                          /*modifiedon*/
        ,COALESCE(TRIM(p0.owneridname),'')                         /*owneridname*/
        ,COALESCE(TRIM(p0.parentaccountidname),'')                 /*parentaccountidname*/
        ,TO_DATE(:TXDATE, 'YYYYMMDD')                              /*Scd_Start_Dt*/
        ,TO_DATE(:MAXDATE,'YYYYMMDD')                              /*Scd_End_Dt*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_crm_account',1,3)                           /*Src_Sysname*/
        ,'s98_s_crm_account'                                       /*Src_Table*/
        
FROM p10_sa.s98_s_crm_account  p0
;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_crm_account_agi_INS (
         name                                                      /*name*/
        ,tek_channelidname                                         /*tek_channelidname*/
        ,address1_city                                             /*address1_city*/
        ,tek_address1_stateidname                                  /*tek_address1_stateidname*/
        ,tek_address1_countryidname                                /*tek_address1_countryidname*/
        ,address1_line1                                            /*address1_line1*/
        ,address1_postalcode                                       /*address1_postalcode*/
        ,tek_accountterritoryidname                                /*tek_accountterritoryidname*/
        ,statecodename                                             /*statecodename*/
        ,tek_omarcustomercode                                      /*tek_omarcustomercode*/
        ,tek_erpsitenumber                                         /*tek_erpsitenumber*/
        ,tek_newcountofactivecontacts                              /*tek_newcountofactivecontacts*/
        ,tek_countofcases                                          /*tek_countofcases*/
        ,tek_countofleads                                          /*tek_countofleads*/
        ,tek_countofopportunities                                  /*tek_countofopportunities*/
        ,tek_countofnamedaccount                                   /*tek_countofnamedaccount*/
        ,createdbyname                                             /*createdbyname*/
        ,createdon                                                 /*createdon*/
        ,tek_3yearvalue                                            /*tek_3yearvalue*/
        ,tek_3yrordertotal                                         /*tek_3yrordertotal*/
        ,customertypecodename                                      /*customertypecodename*/
        ,adx_activeopportunitycount                                /*adx_activeopportunitycount*/
        ,donotbulkemail                                            /*donotbulkemail*/
        ,donotbulkpostalmail                                       /*donotbulkpostalmail*/
        ,donotemail                                                /*donotemail*/
        ,donotfax                                                  /*donotfax*/
        ,donotpostalmail                                           /*donotpostalmail*/
        ,donotphone                                                /*donotphone*/
        ,ftv_dqphoneclean                                          /*ftv_dqphoneclean*/
        ,tek_op_duplicatestatusname                                /*tek_op_duplicatestatusname*/
        ,tek_plussetupcompletedname                                /*tek_plussetupcompletedname*/
        ,tek_customeridname                                        /*tek_customeridname*/
        ,tek_industryidname                                        /*tek_industryidname*/
        ,tek_mkto_channel                                          /*tek_mkto_channel*/
        ,tek_mkto_region                                           /*tek_mkto_region*/
        ,modifiedbyname                                            /*modifiedbyname*/
        ,modifiedon                                                /*modifiedon*/
        ,owneridname                                               /*owneridname*/
        ,parentaccountidname                                       /*parentaccountidname*/
        ,accountnumber                                             /*accountnumber*/
        ,Scd_Start_Dt                                              /*开始时间*/
        ,Scd_End_Dt                                                /*结束时间*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.name                                                      /*name*/
        ,P1.tek_channelidname                                         /*tek_channelidname*/
        ,P1.address1_city                                             /*address1_city*/
        ,P1.tek_address1_stateidname                                  /*tek_address1_stateidname*/
        ,P1.tek_address1_countryidname                                /*tek_address1_countryidname*/
        ,P1.address1_line1                                            /*address1_line1*/
        ,P1.address1_postalcode                                       /*address1_postalcode*/
        ,P1.tek_accountterritoryidname                                /*tek_accountterritoryidname*/
        ,P1.statecodename                                             /*statecodename*/
        ,P1.tek_omarcustomercode                                      /*tek_omarcustomercode*/
        ,P1.tek_erpsitenumber                                         /*tek_erpsitenumber*/
        ,P1.tek_newcountofactivecontacts                              /*tek_newcountofactivecontacts*/
        ,P1.tek_countofcases                                          /*tek_countofcases*/
        ,P1.tek_countofleads                                          /*tek_countofleads*/
        ,P1.tek_countofopportunities                                  /*tek_countofopportunities*/
        ,P1.tek_countofnamedaccount                                   /*tek_countofnamedaccount*/
        ,P1.createdbyname                                             /*createdbyname*/
        ,P1.createdon                                                 /*createdon*/
        ,P1.tek_3yearvalue                                            /*tek_3yearvalue*/
        ,P1.tek_3yrordertotal                                         /*tek_3yrordertotal*/
        ,P1.customertypecodename                                      /*customertypecodename*/
        ,P1.adx_activeopportunitycount                                /*adx_activeopportunitycount*/
        ,P1.donotbulkemail                                            /*donotbulkemail*/
        ,P1.donotbulkpostalmail                                       /*donotbulkpostalmail*/
        ,P1.donotemail                                                /*donotemail*/
        ,P1.donotfax                                                  /*donotfax*/
        ,P1.donotpostalmail                                           /*donotpostalmail*/
        ,P1.donotphone                                                /*donotphone*/
        ,P1.ftv_dqphoneclean                                          /*ftv_dqphoneclean*/
        ,P1.tek_op_duplicatestatusname                                /*tek_op_duplicatestatusname*/
        ,P1.tek_plussetupcompletedname                                /*tek_plussetupcompletedname*/
        ,P1.tek_customeridname                                        /*tek_customeridname*/
        ,P1.tek_industryidname                                        /*tek_industryidname*/
        ,P1.tek_mkto_channel                                          /*tek_mkto_channel*/
        ,P1.tek_mkto_region                                           /*tek_mkto_region*/
        ,P1.modifiedbyname                                            /*modifiedbyname*/
        ,P1.modifiedon                                                /*modifiedon*/
        ,P1.owneridname                                               /*owneridname*/
        ,P1.parentaccountidname                                       /*parentaccountidname*/
        ,P1.accountnumber                                             /*accountnumber*/
        ,P1.Scd_Start_Dt                                              /*开始时间*/
        ,P1.Scd_End_Dt                                                /*结束时间*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_crm_account_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_crm_account P2
ON    P1.name = P2.name
    AND P1.tek_channelidname = P2.tek_channelidname
    AND P1.address1_city = P2.address1_city
    AND P1.tek_address1_stateidname = P2.tek_address1_stateidname
    AND P1.tek_address1_countryidname = P2.tek_address1_countryidname
    AND P1.address1_line1 = P2.address1_line1
    AND P1.address1_postalcode = P2.address1_postalcode
    AND P1.tek_accountterritoryidname = P2.tek_accountterritoryidname
    AND P1.statecodename = P2.statecodename
    AND P1.tek_omarcustomercode = P2.tek_omarcustomercode
    AND P1.tek_erpsitenumber = P2.tek_erpsitenumber
    AND P1.tek_newcountofactivecontacts = P2.tek_newcountofactivecontacts
    AND P1.tek_countofcases = P2.tek_countofcases
    AND P1.tek_countofleads = P2.tek_countofleads
    AND P1.tek_countofopportunities = P2.tek_countofopportunities
    AND P1.tek_countofnamedaccount = P2.tek_countofnamedaccount
    AND P1.createdbyname = P2.createdbyname
    AND P1.createdon = P2.createdon
    AND P1.tek_3yearvalue = P2.tek_3yearvalue
    AND P1.tek_3yrordertotal = P2.tek_3yrordertotal
    AND P1.customertypecodename = P2.customertypecodename
    AND P1.adx_activeopportunitycount = P2.adx_activeopportunitycount
    AND P1.donotbulkemail = P2.donotbulkemail
    AND P1.donotbulkpostalmail = P2.donotbulkpostalmail
    AND P1.donotemail = P2.donotemail
    AND P1.donotfax = P2.donotfax
    AND P1.donotpostalmail = P2.donotpostalmail
    AND P1.donotphone = P2.donotphone
    AND P1.ftv_dqphoneclean = P2.ftv_dqphoneclean
    AND P1.tek_op_duplicatestatusname = P2.tek_op_duplicatestatusname
    AND P1.tek_plussetupcompletedname = P2.tek_plussetupcompletedname
    AND P1.tek_customeridname = P2.tek_customeridname
    AND P1.tek_industryidname = P2.tek_industryidname
    AND P1.tek_mkto_channel = P2.tek_mkto_channel
    AND P1.tek_mkto_region = P2.tek_mkto_region
    AND P1.modifiedbyname = P2.modifiedbyname
    AND P1.modifiedon = P2.modifiedon
    AND P1.owneridname = P2.owneridname
    AND P1.parentaccountidname = P2.parentaccountidname
    AND P1.accountnumber = P2.accountnumber
    
WHERE  P2.name IS NULL
    OR P2.tek_channelidname IS NULL
    OR P2.address1_city IS NULL
    OR P2.tek_address1_stateidname IS NULL
    OR P2.tek_address1_countryidname IS NULL
    OR P2.address1_line1 IS NULL
    OR P2.address1_postalcode IS NULL
    OR P2.tek_accountterritoryidname IS NULL
    OR P2.statecodename IS NULL
    OR P2.tek_omarcustomercode IS NULL
    OR P2.tek_erpsitenumber IS NULL
    OR P2.tek_newcountofactivecontacts IS NULL
    OR P2.tek_countofcases IS NULL
    OR P2.tek_countofleads IS NULL
    OR P2.tek_countofopportunities IS NULL
    OR P2.tek_countofnamedaccount IS NULL
    OR P2.createdbyname IS NULL
    OR P2.createdon IS NULL
    OR P2.tek_3yearvalue IS NULL
    OR P2.tek_3yrordertotal IS NULL
    OR P2.customertypecodename IS NULL
    OR P2.adx_activeopportunitycount IS NULL
    OR P2.donotbulkemail IS NULL
    OR P2.donotbulkpostalmail IS NULL
    OR P2.donotemail IS NULL
    OR P2.donotfax IS NULL
    OR P2.donotpostalmail IS NULL
    OR P2.donotphone IS NULL
    OR P2.ftv_dqphoneclean IS NULL
    OR P2.tek_op_duplicatestatusname IS NULL
    OR P2.tek_plussetupcompletedname IS NULL
    OR P2.tek_customeridname IS NULL
    OR P2.tek_industryidname IS NULL
    OR P2.tek_mkto_channel IS NULL
    OR P2.tek_mkto_region IS NULL
    OR P2.modifiedbyname IS NULL
    OR P2.modifiedon IS NULL
    OR P2.owneridname IS NULL
    OR P2.parentaccountidname IS NULL
    OR P2.accountnumber IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_crm_account (
         name                                                      /*name*/
        ,tek_channelidname                                         /*tek_channelidname*/
        ,address1_city                                             /*address1_city*/
        ,tek_address1_stateidname                                  /*tek_address1_stateidname*/
        ,tek_address1_countryidname                                /*tek_address1_countryidname*/
        ,address1_line1                                            /*address1_line1*/
        ,address1_postalcode                                       /*address1_postalcode*/
        ,tek_accountterritoryidname                                /*tek_accountterritoryidname*/
        ,statecodename                                             /*statecodename*/
        ,tek_omarcustomercode                                      /*tek_omarcustomercode*/
        ,tek_erpsitenumber                                         /*tek_erpsitenumber*/
        ,tek_newcountofactivecontacts                              /*tek_newcountofactivecontacts*/
        ,tek_countofcases                                          /*tek_countofcases*/
        ,tek_countofleads                                          /*tek_countofleads*/
        ,tek_countofopportunities                                  /*tek_countofopportunities*/
        ,tek_countofnamedaccount                                   /*tek_countofnamedaccount*/
        ,createdbyname                                             /*createdbyname*/
        ,createdon                                                 /*createdon*/
        ,tek_3yearvalue                                            /*tek_3yearvalue*/
        ,tek_3yrordertotal                                         /*tek_3yrordertotal*/
        ,customertypecodename                                      /*customertypecodename*/
        ,adx_activeopportunitycount                                /*adx_activeopportunitycount*/
        ,donotbulkemail                                            /*donotbulkemail*/
        ,donotbulkpostalmail                                       /*donotbulkpostalmail*/
        ,donotemail                                                /*donotemail*/
        ,donotfax                                                  /*donotfax*/
        ,donotpostalmail                                           /*donotpostalmail*/
        ,donotphone                                                /*donotphone*/
        ,ftv_dqphoneclean                                          /*ftv_dqphoneclean*/
        ,tek_op_duplicatestatusname                                /*tek_op_duplicatestatusname*/
        ,tek_plussetupcompletedname                                /*tek_plussetupcompletedname*/
        ,tek_customeridname                                        /*tek_customeridname*/
        ,tek_industryidname                                        /*tek_industryidname*/
        ,tek_mkto_channel                                          /*tek_mkto_channel*/
        ,tek_mkto_region                                           /*tek_mkto_region*/
        ,modifiedbyname                                            /*modifiedbyname*/
        ,modifiedon                                                /*modifiedon*/
        ,owneridname                                               /*owneridname*/
        ,parentaccountidname                                       /*parentaccountidname*/
        ,accountnumber                                             /*accountnumber*/
        ,Scd_Start_Dt                                              /*开始时间*/
        ,Scd_End_Dt                                                /*结束时间*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.name                                                      /*name*/
        ,P1.tek_channelidname                                         /*tek_channelidname*/
        ,P1.address1_city                                             /*address1_city*/
        ,P1.tek_address1_stateidname                                  /*tek_address1_stateidname*/
        ,P1.tek_address1_countryidname                                /*tek_address1_countryidname*/
        ,P1.address1_line1                                            /*address1_line1*/
        ,P1.address1_postalcode                                       /*address1_postalcode*/
        ,P1.tek_accountterritoryidname                                /*tek_accountterritoryidname*/
        ,P1.statecodename                                             /*statecodename*/
        ,P1.tek_omarcustomercode                                      /*tek_omarcustomercode*/
        ,P1.tek_erpsitenumber                                         /*tek_erpsitenumber*/
        ,P1.tek_newcountofactivecontacts                              /*tek_newcountofactivecontacts*/
        ,P1.tek_countofcases                                          /*tek_countofcases*/
        ,P1.tek_countofleads                                          /*tek_countofleads*/
        ,P1.tek_countofopportunities                                  /*tek_countofopportunities*/
        ,P1.tek_countofnamedaccount                                   /*tek_countofnamedaccount*/
        ,P1.createdbyname                                             /*createdbyname*/
        ,P1.createdon                                                 /*createdon*/
        ,P1.tek_3yearvalue                                            /*tek_3yearvalue*/
        ,P1.tek_3yrordertotal                                         /*tek_3yrordertotal*/
        ,P1.customertypecodename                                      /*customertypecodename*/
        ,P1.adx_activeopportunitycount                                /*adx_activeopportunitycount*/
        ,P1.donotbulkemail                                            /*donotbulkemail*/
        ,P1.donotbulkpostalmail                                       /*donotbulkpostalmail*/
        ,P1.donotemail                                                /*donotemail*/
        ,P1.donotfax                                                  /*donotfax*/
        ,P1.donotpostalmail                                           /*donotpostalmail*/
        ,P1.donotphone                                                /*donotphone*/
        ,P1.ftv_dqphoneclean                                          /*ftv_dqphoneclean*/
        ,P1.tek_op_duplicatestatusname                                /*tek_op_duplicatestatusname*/
        ,P1.tek_plussetupcompletedname                                /*tek_plussetupcompletedname*/
        ,P1.tek_customeridname                                        /*tek_customeridname*/
        ,P1.tek_industryidname                                        /*tek_industryidname*/
        ,P1.tek_mkto_channel                                          /*tek_mkto_channel*/
        ,P1.tek_mkto_region                                           /*tek_mkto_region*/
        ,P1.modifiedbyname                                            /*modifiedbyname*/
        ,P1.modifiedon                                                /*modifiedon*/
        ,P1.owneridname                                               /*owneridname*/
        ,P1.parentaccountidname                                       /*parentaccountidname*/
        ,P1.accountnumber                                             /*accountnumber*/
        ,P1.Scd_Start_Dt                                              /*开始时间*/
        ,P1.Scd_End_Dt                                                /*结束时间*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_crm_account_agi_INS P1
ON CONFLICT ( accountnumber)
DO UPDATE SET
     accountnumber=excluded.accountnumber
    ,name=excluded.name
    ,tek_channelidname=excluded.tek_channelidname
    ,address1_city=excluded.address1_city
    ,tek_address1_stateidname=excluded.tek_address1_stateidname
    ,tek_address1_countryidname=excluded.tek_address1_countryidname
    ,address1_line1=excluded.address1_line1
    ,address1_postalcode=excluded.address1_postalcode
    ,tek_accountterritoryidname=excluded.tek_accountterritoryidname
    ,statecodename=excluded.statecodename
    ,tek_omarcustomercode=excluded.tek_omarcustomercode
    ,tek_erpsitenumber=excluded.tek_erpsitenumber
    ,tek_newcountofactivecontacts=excluded.tek_newcountofactivecontacts
    ,tek_countofcases=excluded.tek_countofcases
    ,tek_countofleads=excluded.tek_countofleads
    ,tek_countofopportunities=excluded.tek_countofopportunities
    ,tek_countofnamedaccount=excluded.tek_countofnamedaccount
    ,createdbyname=excluded.createdbyname
    ,createdon=excluded.createdon
    ,tek_3yearvalue=excluded.tek_3yearvalue
    ,tek_3yrordertotal=excluded.tek_3yrordertotal
    ,customertypecodename=excluded.customertypecodename
    ,adx_activeopportunitycount=excluded.adx_activeopportunitycount
    ,donotbulkemail=excluded.donotbulkemail
    ,donotbulkpostalmail=excluded.donotbulkpostalmail
    ,donotemail=excluded.donotemail
    ,donotfax=excluded.donotfax
    ,donotpostalmail=excluded.donotpostalmail
    ,donotphone=excluded.donotphone
    ,ftv_dqphoneclean=excluded.ftv_dqphoneclean
    ,tek_op_duplicatestatusname=excluded.tek_op_duplicatestatusname
    ,tek_plussetupcompletedname=excluded.tek_plussetupcompletedname
    ,tek_customeridname=excluded.tek_customeridname
    ,tek_industryidname=excluded.tek_industryidname
    ,tek_mkto_channel=excluded.tek_mkto_channel
    ,tek_mkto_region=excluded.tek_mkto_region
    ,modifiedbyname=excluded.modifiedbyname
    ,modifiedon=excluded.modifiedon
    ,owneridname=excluded.owneridname
    ,parentaccountidname=excluded.parentaccountidname
    ,Scd_Start_Dt=excluded.Scd_Start_Dt
    ,Scd_End_Dt=excluded.Scd_End_Dt
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

