
DROP TABLE IF EXISTS p20_pdm.t01_crm_opportunity;
CREATE TABLE IF NOT EXISTS p20_pdm.t01_crm_opportunity (
	 tek_opportunity_id  varchar(20) 
	, opportunity_name  varchar(100) 
	, tektronix_apname  text 
	, estimated_close_time  timestamp(0) 
	, parent_account_name  varchar(200) 
	, parent_contact_name  varchar(20) 
	, product_name  varchar(50) 
	, product_class  varchar(50) 
	, currency_name  varchar(20) 
	, uint_price  int 
	, discount_percent  numeric(12,4) 
	, discount_amount_base  numeric(16,4) 
	, base_amount  numeric(16,4) 
	, total_amount  numeric(16,4) 
	, sales_funnel_stage  varchar(50) 
	, sales_funnel_stage_id  int 
	, status  varchar(50) 
	, state  varchar(10) 
	, region  varchar(10) 
	, acount_manager  varchar(20) 
	, territory_id  varchar(50) 
	, forecast_opp_ind  varchar(10) 
	, risk_ind  varchar(10) 
	, opportunity_age  int 
	, create_time  timestamp(0) 
	, create_person  varchar(50) 
	, pipline_last_update  timestamp(0) 
	, status_last_update  timestamp(0) 
	, channel_id  varchar(50) 
	, purchase_method  varchar(50) 
	, campaign_name  varchar(50) 
	, web_medium  varchar(50) 
	, web_source  varchar(100) 
	, customer_app  varchar(50) 
	, vertical_segment  varchar(50) 
	, competitive_status  varchar(50) 
	, important_opportunity_ind  varchar(10) 
	, application_name  varchar(100) 
	, opp_industry  varchar(100) 
	, tag_list  varchar(100) 
	, discount_amount  numeric(16,4) 
	, area_id  varchar(100) 
	, branch_id  varchar(100) 
	, extension_id  varchar(100) 
	, legal_company_name  varchar(200) 
	, account_number  varchar(100) 
	, marketing_program_type  varchar(100) 
	, lead_number  varchar(20) 
	, crm_contact_number  varchar(20) 
	, Scd_Start_Dt  date 
	, Scd_End_Dt  date 
	, Etl_Batch_No  varchar(50) 
	, Etl_First_Dt  timestamp(0) 
	, Etl_Job  varchar(50) 
	, Etl_Proc_Dt  timestamp(0) 
	, Etl_Tx_Dt  timestamp(0) 
	, Src_Sysname  varchar(50) 
	, Src_Table  varchar(50) 
	,primary key( tek_opportunity_id,Scd_Start_Dt )
);

 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.tek_opportunity_id IS '泰克机会编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.opportunity_name IS '机会名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.tektronix_apname IS 'tek_tektronixapname'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.estimated_close_time IS '预期关闭时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.parent_account_name IS '父账号名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.parent_contact_name IS '父联系人名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.product_name IS '产品名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.product_class IS '产品类别'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.currency_name IS '交易币种'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.uint_price IS '单价'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.discount_percent IS '折扣率'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.discount_amount_base IS '基础折扣金额'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.base_amount IS '基础金额'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.total_amount IS '总金额'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.sales_funnel_stage IS '销售漏斗层级'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.sales_funnel_stage_id IS '销售漏斗层级编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.status IS '状况'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.state IS '状态'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.region IS '区域'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.acount_manager IS '账号经理'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.territory_id IS '领域编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.forecast_opp_ind IS '预期机会标志'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.risk_ind IS '风险标志'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.opportunity_age IS '机会年份'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.create_time IS '创建时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.create_person IS '创建人'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.pipline_last_update IS 'pipline最后更新时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.status_last_update IS '状况最后更新时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.channel_id IS '渠道编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.purchase_method IS '采购方式'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.campaign_name IS '活动名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.web_medium IS '网络媒介'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.web_source IS '网络来源'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.customer_app IS '客户应用'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.vertical_segment IS '垂直领域'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.competitive_status IS '竞争状态'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.important_opportunity_ind IS '重要机会标志'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.application_name IS '应用名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.opp_industry IS '行业（opp)'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.tag_list IS '标签列表'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.discount_amount IS '折扣金额'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.area_id IS '地区编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.branch_id IS '分支编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.extension_id IS '扩展编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.legal_company_name IS '法定公司名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.account_number IS '账号编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.marketing_program_type IS '市场项目类型'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.lead_number IS '线索编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.crm_contact_number IS '联系人编号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Scd_Start_Dt IS '开始时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Scd_End_Dt IS '结束时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Etl_Batch_No IS '作业批次号'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Etl_First_Dt IS '最初入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Etl_Job IS '作业名称'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Etl_Proc_Dt IS '本次入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Etl_Tx_Dt IS '作业运行时间'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Src_Sysname IS '来源系统'; 
 COMMENT ON COLUMN p20_pdm.t01_crm_opportunity.Src_Table IS '来源表'; 

COMMENT ON TABLE p20_pdm.t01_crm_opportunity IS 'CRM销售机会';