/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_crm_opportunity(CRM销售机会)             */
/*Create Date:2024-04-19 16:39:32                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-04-19                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-04-19                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_crm_opp                                                             */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_crm_opportunity                                                                 */
/*ETL Job Name:t01_crm_opportunity                                                                 */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F5                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_CUR_I 
 ( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_INS 
( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;

/*创建临时表加载当前有效数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_CUR 
( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;

/*创建临时表加载缺失数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_CUR_D 
( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;


/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_crm_opp*****************************************************************/
/*****************************************************************************************************/
INSERT INTO t01_crm_opportunity_agi_CUR_I (
            tek_opportunity_id                      /*泰克机会编号*/
           ,opportunity_name                        /*机会名称*/
           ,tektronix_apname                        /*tek_tektronixapname*/
           ,estimated_close_time                    /*预期关闭时间*/
           ,parent_account_name                     /*父账号名称*/
           ,parent_contact_name                     /*父联系人名称*/
           ,product_name                            /*产品名称*/
           ,product_class                           /*产品类别*/
           ,currency_name                           /*交易币种*/
           ,uint_price                              /*单价*/
           ,discount_percent                        /*折扣率*/
           ,discount_amount_base                    /*基础折扣金额*/
           ,base_amount                             /*基础金额*/
           ,total_amount                            /*总金额*/
           ,sales_funnel_stage                      /*销售漏斗层级*/
           ,sales_funnel_stage_id                   /*销售漏斗层级编号*/
           ,status                                  /*状况*/
           ,state                                   /*状态*/
           ,region                                  /*区域*/
           ,acount_manager                          /*账号经理*/
           ,territory_id                            /*领域编号*/
           ,forecast_opp_ind                        /*预期机会标志*/
           ,risk_ind                                /*风险标志*/
           ,opportunity_age                         /*机会年份*/
           ,create_time                             /*创建时间*/
           ,create_person                           /*创建人*/
           ,pipline_last_update                     /*pipline最后更新时间*/
           ,status_last_update                      /*状况最后更新时间*/
           ,channel_id                              /*渠道编号*/
           ,purchase_method                         /*采购方式*/
           ,campaign_name                           /*活动名称*/
           ,web_medium                              /*网络媒介*/
           ,web_source                              /*网络来源*/
           ,customer_app                            /*客户应用*/
           ,vertical_segment                        /*垂直领域*/
           ,competitive_status                      /*竞争状态*/
           ,important_opportunity_ind               /*重要机会标志*/
           ,application_name                        /*应用名称*/
           ,opp_industry                            /*行业（opp)*/
           ,tag_list                                /*标签列表*/
           ,discount_amount                         /*折扣金额*/
           ,area_id                                 /*地区编号*/
           ,branch_id                               /*分支编号*/
           ,extension_id                            /*扩展编号*/
           ,legal_company_name                      /*法定公司名称*/
           ,account_number                          /*账号编号*/
           ,marketing_program_type                  /*市场项目类型*/
           ,lead_number                             /*线索编号*/
           ,crm_contact_number                      /*联系人编号*/
           ,Scd_Start_Dt                            /*开始时间*/
           ,Scd_End_Dt                              /*结束时间*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.tek_opportunitynumber AS varchar(20))),'')        /*tek_opportunity_id*/
        ,COALESCE(TRIM(CAST(p0.name AS varchar(100))),'')          /*opportunity_name*/
        ,COALESCE(TRIM(p0.tek_tektronixapname),'')                 /*tektronix_apname*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.estimatedclosedate AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*estimated_close_time*/
        ,COALESCE(TRIM(CAST(p0.parentaccountidname AS varchar(200))),'')        /*parent_account_name*/
        ,COALESCE(TRIM(CAST(p0.parentcontactidname AS varchar(20))),'')        /*parent_contact_name*/
        ,COALESCE(TRIM(CAST(p0.tek_productidname AS varchar(50))),'')        /*product_name*/
        ,COALESCE(TRIM(CAST(p0.tek_productfamilyidname AS varchar(50))),'')        /*product_class*/
        ,COALESCE(TRIM(CAST(p0.transactioncurrencyidname AS varchar(20))),'')        /*currency_name*/
        ,COALESCE(CAST(p0.tek_unitpricetotal_base::numeric(12,4) AS int),0)        /*uint_price*/
        ,COALESCE(CAST(p0.tek_totaldiscountpercent AS numeric(12,4)),0)        /*discount_percent*/
        ,COALESCE(CAST(p0.totaldiscountamount_base AS numeric(16,4)),0)        /*discount_amount_base*/
        ,COALESCE(CAST(p0.estimatedvalue_base AS numeric(16,4)),0)        /*base_amount*/
        ,COALESCE(CAST(p0.totalamount AS numeric(16,4)),0)         /*total_amount*/
        ,COALESCE(TRIM(CAST(p0.tek_salesfunnelstagename AS varchar(50))),'')        /*sales_funnel_stage*/
        ,COALESCE(CAST(p0.tek_funnelstagenumber AS int),0)         /*sales_funnel_stage_id*/
        ,COALESCE(TRIM(CAST(p0.statuscodename AS varchar(50))),'')        /*status*/
        ,COALESCE(TRIM(CAST(p0.statecodename AS varchar(10))),'')        /*state*/
        ,COALESCE(TRIM(CAST(p0.tek_regionidname AS varchar(10))),'')        /*region*/
        ,COALESCE(TRIM(CAST(p0.tek_accountmanageridname AS varchar(20))),'')        /*acount_manager*/
        ,COALESCE(TRIM(CAST(p0.tek_oppterritoryidname AS varchar(50))),'')        /*territory_id*/
        ,COALESCE(TRIM(CAST(p0.tek_opp_includeinforecastname AS varchar(10))),'')        /*forecast_opp_ind*/
        ,COALESCE(TRIM(CAST(p0.tek_isriskname AS varchar(10))),'')        /*risk_ind*/
        ,COALESCE(CAST(p0.TEK_OPPORTUNITYAGE::numeric(12,4) AS int),0)        /*opportunity_age*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.createdon AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*create_time*/
        ,COALESCE(TRIM(CAST(p0.createdbyname AS varchar(50))),'')        /*create_person*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.tek_piplinelastupdatedon AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*pipline_last_update*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.tek_laststatusdate AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*status_last_update*/
        ,COALESCE(TRIM(CAST(p0.tek_channelidname AS varchar(50))),'')        /*channel_id*/
        ,COALESCE(TRIM(CAST(p0.tek_purchasemethodname AS varchar(50))),'')        /*purchase_method*/
        ,COALESCE(TRIM(CAST(p0.campaignidname AS varchar(50))),'')        /*campaign_name*/
        ,COALESCE(TRIM(CAST(p0.tek_webvisitormedium AS varchar(50))),'')        /*web_medium*/
        ,COALESCE(TRIM(CAST(p0.tek_webvisitorsource AS varchar(100))),'')        /*web_source*/
        ,COALESCE(TRIM(CAST(p0.tek_customerapplication AS varchar(50))),'')        /*customer_app*/
        ,COALESCE(TRIM(CAST(p0.tek_vertical_segmentname AS varchar(50))),'')        /*vertical_segment*/
        ,COALESCE(TRIM(CAST(p0.tek_competitivestatusname AS varchar(50))),'')        /*competitive_status*/
        ,COALESCE(TRIM(CAST(p0.tek_importantopportunityname AS varchar(10))),'')        /*important_opportunity_ind*/
        ,COALESCE(TRIM(CAST(p0.tek_applicationidname AS varchar(100))),'')        /*application_name*/
        ,COALESCE(TRIM(CAST(p0.tek_industryidname AS varchar(100))),'')        /*opp_industry*/
        ,COALESCE(TRIM(CAST(p0.tek_taglist AS varchar(100))),'')        /*tag_list*/
        ,COALESCE(CAST(p0.discountamount AS numeric(16,4)),0)        /*discount_amount*/
        ,COALESCE(TRIM(CAST(p0.tek_terr_areaidname AS varchar(100))),'')        /*area_id*/
        ,COALESCE(TRIM(CAST(p0.tek_terr_branchidname AS varchar(100))),'')        /*branch_id*/
        ,COALESCE(TRIM(CAST(p0.tek_extension AS varchar(100))),'')        /*extension_id*/
        ,COALESCE(TRIM(CAST(p0.tek_companynamelegal AS varchar(200))),'')        /*legal_company_name*/
        ,COALESCE(TRIM(CAST(p0.accountnumber AS varchar(100))),'')        /*account_number*/
        ,COALESCE(TRIM(CAST(p0.tek_marketing_program_type_idname AS varchar(100))),'')        /*marketing_program_type*/
        ,COALESCE(TRIM(CAST(p0.tek_leadnumber AS varchar(20))),'')        /*lead_number*/
        ,COALESCE(TRIM(CAST(p0.tek_contactnumber AS varchar(20))),'')        /*crm_contact_number*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Scd_Start_Dt*/
        ,TO_DATE(:MAXDATE,'YYYYMMDD')                              /*Scd_End_Dt*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_crm_opp',1,3)                               /*Src_Sysname*/
        ,'s98_s_crm_opp'                                           /*Src_Table*/
        
FROM p10_sa.s98_s_crm_opp  p0
;



/*避免同一天多次运行造成数据重复                                                                   */

DELETE FROM :PDMDB.t01_crm_opportunity
WHERE ETL_JOB=:ETLJOB 
AND scd_End_Dt=TO_DATE(:MAXDATE,'YYYYMMDD')
AND scd_Start_Dt=TO_DATE(:TXDATE,'YYYYMMDD');
UPDATE :PDMDB.t01_crm_opportunity
SET scd_End_Dt=TO_DATE(:MAXDATE,'YYYYMMDD')
WHERE ETL_JOB=:ETLJOB
AND scd_End_Dt=TO_DATE(:TXDATE,'YYYYMMDD'); 

/*往临时表插入当前数据。                                                               */
INSERT INTO t01_crm_opportunity_agi_CUR(
     tek_opportunity_id                                        /*泰克机会编号*/
    ,uint_price                                                /*单价*/
    ,discount_percent                                          /*折扣率*/
    ,discount_amount_base                                      /*基础折扣金额*/
    ,base_amount                                               /*基础金额*/
    ,total_amount                                              /*总金额*/
    ,sales_funnel_stage                                        /*销售漏斗层级*/
    ,sales_funnel_stage_id                                     /*销售漏斗层级编号*/
    ,status                                                    /*状况*/
    ,state                                                     /*状态*/
    ,region                                                    /*区域*/
    ,opportunity_name                                          /*机会名称*/
    ,acount_manager                                            /*账号经理*/
    ,territory_id                                              /*领域编号*/
    ,forecast_opp_ind                                          /*预期机会标志*/
    ,risk_ind                                                  /*风险标志*/
    ,opportunity_age                                           /*机会年份*/
    ,create_time                                               /*创建时间*/
    ,create_person                                             /*创建人*/
    ,pipline_last_update                                       /*pipline最后更新时间*/
    ,status_last_update                                        /*状况最后更新时间*/
    ,channel_id                                                /*渠道编号*/
    ,tektronix_apname                                          /*tek_tektronixapname*/
    ,purchase_method                                           /*采购方式*/
    ,campaign_name                                             /*活动名称*/
    ,web_medium                                                /*网络媒介*/
    ,web_source                                                /*网络来源*/
    ,customer_app                                              /*客户应用*/
    ,vertical_segment                                          /*垂直领域*/
    ,competitive_status                                        /*竞争状态*/
    ,important_opportunity_ind                                 /*重要机会标志*/
    ,application_name                                          /*应用名称*/
    ,opp_industry                                              /*行业（opp)*/
    ,estimated_close_time                                      /*预期关闭时间*/
    ,tag_list                                                  /*标签列表*/
    ,discount_amount                                           /*折扣金额*/
    ,area_id                                                   /*地区编号*/
    ,branch_id                                                 /*分支编号*/
    ,extension_id                                              /*扩展编号*/
    ,legal_company_name                                        /*法定公司名称*/
    ,account_number                                            /*账号编号*/
    ,marketing_program_type                                    /*市场项目类型*/
    ,lead_number                                               /*线索编号*/
    ,crm_contact_number                                        /*联系人编号*/
    ,parent_account_name                                       /*父账号名称*/
    ,Scd_Start_Dt                                              /*开始时间*/
    ,Scd_End_Dt                                                /*结束时间*/
    ,Etl_Batch_No                                              /*作业批次号*/
    ,Etl_First_Dt                                              /*最初入库时间*/
    ,Etl_Job                                                   /*作业名称*/
    ,Etl_Proc_Dt                                               /*本次入库时间*/
    ,Etl_Tx_Dt                                                 /*作业运行时间*/
    ,Src_Sysname                                               /*来源系统*/
    ,Src_Table                                                 /*来源表*/
    ,parent_contact_name                                       /*父联系人名称*/
    ,product_name                                              /*产品名称*/
    ,product_class                                             /*产品类别*/
    ,currency_name                                             /*交易币种*/
    )
SELECT      
     P1.tek_opportunity_id                                        /*泰克机会编号*/
    ,P1.uint_price                                                /*单价*/
    ,P1.discount_percent                                          /*折扣率*/
    ,P1.discount_amount_base                                      /*基础折扣金额*/
    ,P1.base_amount                                               /*基础金额*/
    ,P1.total_amount                                              /*总金额*/
    ,P1.sales_funnel_stage                                        /*销售漏斗层级*/
    ,P1.sales_funnel_stage_id                                     /*销售漏斗层级编号*/
    ,P1.status                                                    /*状况*/
    ,P1.state                                                     /*状态*/
    ,P1.region                                                    /*区域*/
    ,P1.opportunity_name                                          /*机会名称*/
    ,P1.acount_manager                                            /*账号经理*/
    ,P1.territory_id                                              /*领域编号*/
    ,P1.forecast_opp_ind                                          /*预期机会标志*/
    ,P1.risk_ind                                                  /*风险标志*/
    ,P1.opportunity_age                                           /*机会年份*/
    ,P1.create_time                                               /*创建时间*/
    ,P1.create_person                                             /*创建人*/
    ,P1.pipline_last_update                                       /*pipline最后更新时间*/
    ,P1.status_last_update                                        /*状况最后更新时间*/
    ,P1.channel_id                                                /*渠道编号*/
    ,P1.tektronix_apname                                          /*tek_tektronixapname*/
    ,P1.purchase_method                                           /*采购方式*/
    ,P1.campaign_name                                             /*活动名称*/
    ,P1.web_medium                                                /*网络媒介*/
    ,P1.web_source                                                /*网络来源*/
    ,P1.customer_app                                              /*客户应用*/
    ,P1.vertical_segment                                          /*垂直领域*/
    ,P1.competitive_status                                        /*竞争状态*/
    ,P1.important_opportunity_ind                                 /*重要机会标志*/
    ,P1.application_name                                          /*应用名称*/
    ,P1.opp_industry                                              /*行业（opp)*/
    ,P1.estimated_close_time                                      /*预期关闭时间*/
    ,P1.tag_list                                                  /*标签列表*/
    ,P1.discount_amount                                           /*折扣金额*/
    ,P1.area_id                                                   /*地区编号*/
    ,P1.branch_id                                                 /*分支编号*/
    ,P1.extension_id                                              /*扩展编号*/
    ,P1.legal_company_name                                        /*法定公司名称*/
    ,P1.account_number                                            /*账号编号*/
    ,P1.marketing_program_type                                    /*市场项目类型*/
    ,P1.lead_number                                               /*线索编号*/
    ,P1.crm_contact_number                                        /*联系人编号*/
    ,P1.parent_account_name                                       /*父账号名称*/
    ,P1.Scd_Start_Dt                                              /*开始时间*/
    ,P1.Scd_End_Dt                                                /*结束时间*/
    ,P1.Etl_Batch_No                                              /*作业批次号*/
    ,P1.Etl_First_Dt                                              /*最初入库时间*/
    ,P1.Etl_Job                                                   /*作业名称*/
    ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
    ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
    ,P1.Src_Sysname                                               /*来源系统*/
    ,P1.Src_Table                                                 /*来源表*/
    ,P1.parent_contact_name                                       /*父联系人名称*/
    ,P1.product_name                                              /*产品名称*/
    ,P1.product_class                                             /*产品类别*/
    ,P1.currency_name                                             /*交易币种*/
    
FROM    :PDMDB.t01_crm_opportunity P1
WHERE    P1.Scd_End_Dt   = TO_DATE(:MAXDATE,'YYYYMMDD')
    AND P1.ETL_Job  = :ETLJOB
    ;
/*"今日数据"与"当前有效数据"进行比较找出新增及更新的数据，比对条件是：除去开始日期和结束日期的所有 */
/*字段。                                                                                           */
INSERT INTO t01_crm_opportunity_agi_INS(
     tek_opportunity_id                                        /*泰克机会编号*/
     , uint_price                                                /*单价*/
     , discount_percent                                          /*折扣率*/
     , discount_amount_base                                      /*基础折扣金额*/
     , base_amount                                               /*基础金额*/
     , total_amount                                              /*总金额*/
     , sales_funnel_stage                                        /*销售漏斗层级*/
     , sales_funnel_stage_id                                     /*销售漏斗层级编号*/
     , status                                                    /*状况*/
     , state                                                     /*状态*/
     , region                                                    /*区域*/
     , opportunity_name                                          /*机会名称*/
     , acount_manager                                            /*账号经理*/
     , territory_id                                              /*领域编号*/
     , forecast_opp_ind                                          /*预期机会标志*/
     , risk_ind                                                  /*风险标志*/
     , opportunity_age                                           /*机会年份*/
     , create_time                                               /*创建时间*/
     , create_person                                             /*创建人*/
     , pipline_last_update                                       /*pipline最后更新时间*/
     , status_last_update                                        /*状况最后更新时间*/
     , channel_id                                                /*渠道编号*/
     , tektronix_apname                                          /*tek_tektronixapname*/
     , purchase_method                                           /*采购方式*/
     , campaign_name                                             /*活动名称*/
     , web_medium                                                /*网络媒介*/
     , web_source                                                /*网络来源*/
     , customer_app                                              /*客户应用*/
     , vertical_segment                                          /*垂直领域*/
     , competitive_status                                        /*竞争状态*/
     , important_opportunity_ind                                 /*重要机会标志*/
     , application_name                                          /*应用名称*/
     , opp_industry                                              /*行业（opp)*/
     , estimated_close_time                                      /*预期关闭时间*/
     , tag_list                                                  /*标签列表*/
     , discount_amount                                           /*折扣金额*/
     , area_id                                                   /*地区编号*/
     , branch_id                                                 /*分支编号*/
     , extension_id                                              /*扩展编号*/
     , legal_company_name                                        /*法定公司名称*/
     , account_number                                            /*账号编号*/
     , marketing_program_type                                    /*市场项目类型*/
     , lead_number                                               /*线索编号*/
     , crm_contact_number                                        /*联系人编号*/
     , parent_account_name                                       /*父账号名称*/
     , Scd_Start_Dt                                              /*开始时间*/
     , Scd_End_Dt                                                /*结束时间*/
     , Etl_Batch_No                                              /*作业批次号*/
     , Etl_First_Dt                                              /*最初入库时间*/
     , Etl_Job                                                   /*作业名称*/
     , Etl_Proc_Dt                                               /*本次入库时间*/
     , Etl_Tx_Dt                                                 /*作业运行时间*/
     , Src_Sysname                                               /*来源系统*/
     , Src_Table                                                 /*来源表*/
     , parent_contact_name                                       /*父联系人名称*/
     , product_name                                              /*产品名称*/
     , product_class                                             /*产品类别*/
     , currency_name                                             /*交易币种*/
    )
SELECT      
     P1.tek_opportunity_id                                        /*泰克机会编号*/
     , P1.uint_price                                                /*单价*/
     , P1.discount_percent                                          /*折扣率*/
     , P1.discount_amount_base                                      /*基础折扣金额*/
     , P1.base_amount                                               /*基础金额*/
     , P1.total_amount                                              /*总金额*/
     , P1.sales_funnel_stage                                        /*销售漏斗层级*/
     , P1.sales_funnel_stage_id                                     /*销售漏斗层级编号*/
     , P1.status                                                    /*状况*/
     , P1.state                                                     /*状态*/
     , P1.region                                                    /*区域*/
     , P1.opportunity_name                                          /*机会名称*/
     , P1.acount_manager                                            /*账号经理*/
     , P1.territory_id                                              /*领域编号*/
     , P1.forecast_opp_ind                                          /*预期机会标志*/
     , P1.risk_ind                                                  /*风险标志*/
     , P1.opportunity_age                                           /*机会年份*/
     , P1.create_time                                               /*创建时间*/
     , P1.create_person                                             /*创建人*/
     , P1.pipline_last_update                                       /*pipline最后更新时间*/
     , P1.status_last_update                                        /*状况最后更新时间*/
     , P1.channel_id                                                /*渠道编号*/
     , P1.tektronix_apname                                          /*tek_tektronixapname*/
     , P1.purchase_method                                           /*采购方式*/
     , P1.campaign_name                                             /*活动名称*/
     , P1.web_medium                                                /*网络媒介*/
     , P1.web_source                                                /*网络来源*/
     , P1.customer_app                                              /*客户应用*/
     , P1.vertical_segment                                          /*垂直领域*/
     , P1.competitive_status                                        /*竞争状态*/
     , P1.important_opportunity_ind                                 /*重要机会标志*/
     , P1.application_name                                          /*应用名称*/
     , P1.opp_industry                                              /*行业（opp)*/
     , P1.estimated_close_time                                      /*预期关闭时间*/
     , P1.tag_list                                                  /*标签列表*/
     , P1.discount_amount                                           /*折扣金额*/
     , P1.area_id                                                   /*地区编号*/
     , P1.branch_id                                                 /*分支编号*/
     , P1.extension_id                                              /*扩展编号*/
     , P1.legal_company_name                                        /*法定公司名称*/
     , P1.account_number                                            /*账号编号*/
     , P1.marketing_program_type                                    /*市场项目类型*/
     , P1.lead_number                                               /*线索编号*/
     , P1.crm_contact_number                                        /*联系人编号*/
     , P1.parent_account_name                                       /*父账号名称*/
     , P1.Scd_Start_Dt                                              /*开始时间*/
     , P1.Scd_End_Dt                                                /*结束时间*/
     , P1.Etl_Batch_No                                              /*作业批次号*/
     , P1.Etl_First_Dt                                              /*最初入库时间*/
     , P1.Etl_Job                                                   /*作业名称*/
     , P1.Etl_Proc_Dt                                               /*本次入库时间*/
     , P1.Etl_Tx_Dt                                                 /*作业运行时间*/
     , P1.Src_Sysname                                               /*来源系统*/
     , P1.Src_Table                                                 /*来源表*/
     , P1.parent_contact_name                                       /*父联系人名称*/
     , P1.product_name                                              /*产品名称*/
     , P1.product_class                                             /*产品类别*/
     , P1.currency_name                                             /*交易币种*/
    
FROM    t01_crm_opportunity_agi_CUR_I P1
LEFT JOIN t01_crm_opportunity_agi_CUR P2
    ON   P1.tek_opportunity_id = P2.tek_opportunity_id                                
     AND P1.Scd_Start_Dt = P2.Scd_Start_Dt                                      
     AND P1.opportunity_name = P2.opportunity_name                                  
     AND P1.tektronix_apname = P2.tektronix_apname                                  
     AND P1.estimated_close_time = P2.estimated_close_time                              
     AND P1.parent_account_name = P2.parent_account_name                               
     AND P1.parent_contact_name = P2.parent_contact_name                               
     AND P1.product_name = P2.product_name                                      
     AND P1.product_class = P2.product_class                                     
     AND P1.currency_name = P2.currency_name                                     
     AND P1.uint_price = P2.uint_price                                        
     AND P1.discount_percent = P2.discount_percent                                  
     AND P1.discount_amount_base = P2.discount_amount_base                              
     AND P1.base_amount = P2.base_amount                                       
     AND P1.total_amount = P2.total_amount                                      
     AND P1.sales_funnel_stage = P2.sales_funnel_stage                                
     AND P1.sales_funnel_stage_id = P2.sales_funnel_stage_id                             
     AND P1.status = P2.status                                            
     AND P1.state = P2.state                                             
     AND P1.region = P2.region                                            
     AND P1.acount_manager = P2.acount_manager                                    
     AND P1.territory_id = P2.territory_id                                      
     AND P1.forecast_opp_ind = P2.forecast_opp_ind                                  
     AND P1.risk_ind = P2.risk_ind                                          
     AND P1.opportunity_age = P2.opportunity_age                                   
     AND P1.create_time = P2.create_time                                       
     AND P1.create_person = P2.create_person                                     
     AND P1.pipline_last_update = P2.pipline_last_update                               
     AND P1.status_last_update = P2.status_last_update                                
     AND P1.channel_id = P2.channel_id                                        
     AND P1.purchase_method = P2.purchase_method                                   
     AND P1.campaign_name = P2.campaign_name                                     
     AND P1.web_medium = P2.web_medium                                        
     AND P1.web_source = P2.web_source                                        
     AND P1.customer_app = P2.customer_app                                      
     AND P1.vertical_segment = P2.vertical_segment                                  
     AND P1.competitive_status = P2.competitive_status                                
     AND P1.important_opportunity_ind = P2.important_opportunity_ind                         
     AND P1.application_name = P2.application_name                                  
     AND P1.opp_industry = P2.opp_industry                                      
     AND P1.tag_list = P2.tag_list                                          
     AND P1.discount_amount = P2.discount_amount                                   
     AND P1.area_id = P2.area_id                                           
     AND P1.branch_id = P2.branch_id                                         
     AND P1.extension_id = P2.extension_id                                      
     AND P1.legal_company_name = P2.legal_company_name                                
     AND P1.account_number = P2.account_number                                    
     AND P1.marketing_program_type = P2.marketing_program_type                            
     AND P1.lead_number = P2.lead_number                                       
     AND P1.crm_contact_number = P2.crm_contact_number                                
     AND P2.ETL_Job =:ETLJOB
WHERE           
         P2.tek_opportunity_id IS NULL
     AND P2.Scd_Start_Dt IS NULL
     AND P2.opportunity_name IS NULL
     AND P2.tektronix_apname IS NULL
     AND P2.estimated_close_time IS NULL
     AND P2.parent_account_name IS NULL
     AND P2.parent_contact_name IS NULL
     AND P2.product_name IS NULL
     AND P2.product_class IS NULL
     AND P2.currency_name IS NULL
     AND P2.uint_price IS NULL
     AND P2.discount_percent IS NULL
     AND P2.discount_amount_base IS NULL
     AND P2.base_amount IS NULL
     AND P2.total_amount IS NULL
     AND P2.sales_funnel_stage IS NULL
     AND P2.sales_funnel_stage_id IS NULL
     AND P2.status IS NULL
     AND P2.state IS NULL
     AND P2.region IS NULL
     AND P2.acount_manager IS NULL
     AND P2.territory_id IS NULL
     AND P2.forecast_opp_ind IS NULL
     AND P2.risk_ind IS NULL
     AND P2.opportunity_age IS NULL
     AND P2.create_time IS NULL
     AND P2.create_person IS NULL
     AND P2.pipline_last_update IS NULL
     AND P2.status_last_update IS NULL
     AND P2.channel_id IS NULL
     AND P2.purchase_method IS NULL
     AND P2.campaign_name IS NULL
     AND P2.web_medium IS NULL
     AND P2.web_source IS NULL
     AND P2.customer_app IS NULL
     AND P2.vertical_segment IS NULL
     AND P2.competitive_status IS NULL
     AND P2.important_opportunity_ind IS NULL
     AND P2.application_name IS NULL
     AND P2.opp_industry IS NULL
     AND P2.tag_list IS NULL
     AND P2.discount_amount IS NULL
     AND P2.area_id IS NULL
     AND P2.branch_id IS NULL
     AND P2.extension_id IS NULL
     AND P2.legal_company_name IS NULL
     AND P2.account_number IS NULL
     AND P2.marketing_program_type IS NULL
     AND P2.lead_number IS NULL
     AND P2.crm_contact_number IS NULL
    
;


INSERT INTO t01_crm_opportunity_agi_CUR_D (
            tek_opportunity_id                                        /*泰克机会编号*/
            , uint_price                                                /*单价*/
            , discount_percent                                          /*折扣率*/
            , discount_amount_base                                      /*基础折扣金额*/
            , base_amount                                               /*基础金额*/
            , total_amount                                              /*总金额*/
            , sales_funnel_stage                                        /*销售漏斗层级*/
            , sales_funnel_stage_id                                     /*销售漏斗层级编号*/
            , status                                                    /*状况*/
            , state                                                     /*状态*/
            , region                                                    /*区域*/
            , opportunity_name                                          /*机会名称*/
            , acount_manager                                            /*账号经理*/
            , territory_id                                              /*领域编号*/
            , forecast_opp_ind                                          /*预期机会标志*/
            , risk_ind                                                  /*风险标志*/
            , opportunity_age                                           /*机会年份*/
            , create_time                                               /*创建时间*/
            , create_person                                             /*创建人*/
            , pipline_last_update                                       /*pipline最后更新时间*/
            , status_last_update                                        /*状况最后更新时间*/
            , channel_id                                                /*渠道编号*/
            , tektronix_apname                                          /*tek_tektronixapname*/
            , purchase_method                                           /*采购方式*/
            , campaign_name                                             /*活动名称*/
            , web_medium                                                /*网络媒介*/
            , web_source                                                /*网络来源*/
            , customer_app                                              /*客户应用*/
            , vertical_segment                                          /*垂直领域*/
            , competitive_status                                        /*竞争状态*/
            , important_opportunity_ind                                 /*重要机会标志*/
            , application_name                                          /*应用名称*/
            , opp_industry                                              /*行业（opp)*/
            , estimated_close_time                                      /*预期关闭时间*/
            , tag_list                                                  /*标签列表*/
            , discount_amount                                           /*折扣金额*/
            , area_id                                                   /*地区编号*/
            , branch_id                                                 /*分支编号*/
            , extension_id                                              /*扩展编号*/
            , legal_company_name                                        /*法定公司名称*/
            , account_number                                            /*账号编号*/
            , marketing_program_type                                    /*市场项目类型*/
            , lead_number                                               /*线索编号*/
            , crm_contact_number                                        /*联系人编号*/
            , parent_account_name                                       /*父账号名称*/
            , Scd_Start_Dt                                              /*开始时间*/
            , Scd_End_Dt                                                /*结束时间*/
            , Etl_Batch_No                                              /*作业批次号*/
            , Etl_First_Dt                                              /*最初入库时间*/
            , Etl_Job                                                   /*作业名称*/
            , Etl_Proc_Dt                                               /*本次入库时间*/
            , Etl_Tx_Dt                                                 /*作业运行时间*/
            , Src_Sysname                                               /*来源系统*/
            , Src_Table                                                 /*来源表*/
            , parent_contact_name                                       /*父联系人名称*/
            , product_name                                              /*产品名称*/
            , product_class                                             /*产品类别*/
            , currency_name                                             /*交易币种*/
           )
SELECT      
            P1.tek_opportunity_id                                        /*泰克机会编号*/
            , P1.uint_price                                                /*单价*/
            , P1.discount_percent                                          /*折扣率*/
            , P1.discount_amount_base                                      /*基础折扣金额*/
            , P1.base_amount                                               /*基础金额*/
            , P1.total_amount                                              /*总金额*/
            , P1.sales_funnel_stage                                        /*销售漏斗层级*/
            , P1.sales_funnel_stage_id                                     /*销售漏斗层级编号*/
            , P1.status                                                    /*状况*/
            , P1.state                                                     /*状态*/
            , P1.region                                                    /*区域*/
            , P1.opportunity_name                                          /*机会名称*/
            , P1.acount_manager                                            /*账号经理*/
            , P1.territory_id                                              /*领域编号*/
            , P1.forecast_opp_ind                                          /*预期机会标志*/
            , P1.risk_ind                                                  /*风险标志*/
            , P1.opportunity_age                                           /*机会年份*/
            , P1.create_time                                               /*创建时间*/
            , P1.create_person                                             /*创建人*/
            , P1.pipline_last_update                                       /*pipline最后更新时间*/
            , P1.status_last_update                                        /*状况最后更新时间*/
            , P1.channel_id                                                /*渠道编号*/
            , P1.tektronix_apname                                          /*tek_tektronixapname*/
            , P1.purchase_method                                           /*采购方式*/
            , P1.campaign_name                                             /*活动名称*/
            , P1.web_medium                                                /*网络媒介*/
            , P1.web_source                                                /*网络来源*/
            , P1.customer_app                                              /*客户应用*/
            , P1.vertical_segment                                          /*垂直领域*/
            , P1.competitive_status                                        /*竞争状态*/
            , P1.important_opportunity_ind                                 /*重要机会标志*/
            , P1.application_name                                          /*应用名称*/
            , P1.opp_industry                                              /*行业（opp)*/
            , P1.estimated_close_time                                      /*预期关闭时间*/
            , P1.tag_list                                                  /*标签列表*/
            , P1.discount_amount                                           /*折扣金额*/
            , P1.area_id                                                   /*地区编号*/
            , P1.branch_id                                                 /*分支编号*/
            , P1.extension_id                                              /*扩展编号*/
            , P1.legal_company_name                                        /*法定公司名称*/
            , P1.account_number                                            /*账号编号*/
            , P1.marketing_program_type                                    /*市场项目类型*/
            , P1.lead_number                                               /*线索编号*/
            , P1.crm_contact_number                                        /*联系人编号*/
            , P1.parent_account_name                                       /*父账号名称*/
            , P1.Scd_Start_Dt                                              /*开始时间*/
            , P1.Scd_End_Dt                                                /*结束时间*/
            , P1.Etl_Batch_No                                              /*作业批次号*/
            , P1.Etl_First_Dt                                              /*最初入库时间*/
            , P1.Etl_Job                                                   /*作业名称*/
            , P1.Etl_Proc_Dt                                               /*本次入库时间*/
            , P1.Etl_Tx_Dt                                                 /*作业运行时间*/
            , P1.Src_Sysname                                               /*来源系统*/
            , P1.Src_Table                                                 /*来源表*/
            , P1.parent_contact_name                                       /*父联系人名称*/
            , P1.product_name                                              /*产品名称*/
            , P1.product_class                                             /*产品类别*/
            , P1.currency_name                                             /*交易币种*/
           
FROM    t01_crm_opportunity_agi_CUR_I P1
LEFT JOIN t01_crm_opportunity_agi_CUR P2
ON   P1.tek_opportunity_id = P2.tek_opportunity_id                                
AND P1.Scd_Start_Dt = P2.Scd_Start_Dt                                      
WHERE  P2.tek_opportunity_id IS NULL
 AND P2.Scd_Start_Dt IS NULL
AND P2.Scd_End_Dt   = TO_DATE(:MAXDATE,'YYYYMMDD')
AND P2.ETL_Job  = :ETLJOB
;


/*更新目标表中数据,对更新的数据进行封口,即置结束日期为TX_DATE                                      */
UPDATE :PDMDB.t01_crm_opportunity
   SET  Scd_End_Dt   = TO_DATE(:TXDATE,'YYYYMMDD')
        ,Etl_Tx_Dt=:TXDATE
        ,Etl_Proc_Dt=CURRENT_TIMESTAMP(0)
WHERE Scd_End_Dt   = TO_DATE(:MAXDATE, 'YYYYMMDD')
    AND  (:PDMDB.t01_crm_opportunity.ETL_Job = :ETLJOB)
    AND ( tek_opportunity_id , Scd_Start_Dt)
IN  (SELECT  tek_opportunity_id                                 , Scd_Start_Dt                                      
    FROM t01_crm_opportunity_agi_INS) 
                
/*根据比对条件将目标表中删除数据进行相应的处理                                                     */
;UPDATE    :PDMDB.t01_crm_opportunity
   SET    Scd_End_Dt= TO_DATE(:TXDATE, 'YYYYMMDD')
          ,Etl_Tx_Dt=:TXDATE
         ,ETL_Proc_Dt=CURRENT_TIMESTAMP(0)
 WHERE   Scd_End_Dt=TO_DATE(:MAXDATE,'YYYYMMDD')
   AND  (:PDMDB.t01_crm_opportunity.ETL_Job = :ETLJOB)
   AND  ( tek_opportunity_id , Scd_Start_Dt)
IN  (SELECT 
     tek_opportunity_id                                 , Scd_Start_Dt                                      
FROM t01_crm_opportunity_agi_CUR_D)
/*然后将新增的数据插入到目标表中，置开始日期为TX_DATE，结束日期置为MAXDATE                         */
;INSERT INTO :PDMDB.t01_crm_opportunity (
           tek_opportunity_id                                        /*泰克机会编号*/
          ,uint_price                                                /*单价*/
          ,discount_percent                                          /*折扣率*/
          ,discount_amount_base                                      /*基础折扣金额*/
          ,base_amount                                               /*基础金额*/
          ,total_amount                                              /*总金额*/
          ,sales_funnel_stage                                        /*销售漏斗层级*/
          ,sales_funnel_stage_id                                     /*销售漏斗层级编号*/
          ,status                                                    /*状况*/
          ,state                                                     /*状态*/
          ,region                                                    /*区域*/
          ,opportunity_name                                          /*机会名称*/
          ,acount_manager                                            /*账号经理*/
          ,territory_id                                              /*领域编号*/
          ,forecast_opp_ind                                          /*预期机会标志*/
          ,risk_ind                                                  /*风险标志*/
          ,opportunity_age                                           /*机会年份*/
          ,create_time                                               /*创建时间*/
          ,create_person                                             /*创建人*/
          ,pipline_last_update                                       /*pipline最后更新时间*/
          ,status_last_update                                        /*状况最后更新时间*/
          ,channel_id                                                /*渠道编号*/
          ,tektronix_apname                                          /*tek_tektronixapname*/
          ,purchase_method                                           /*采购方式*/
          ,campaign_name                                             /*活动名称*/
          ,web_medium                                                /*网络媒介*/
          ,web_source                                                /*网络来源*/
          ,customer_app                                              /*客户应用*/
          ,vertical_segment                                          /*垂直领域*/
          ,competitive_status                                        /*竞争状态*/
          ,important_opportunity_ind                                 /*重要机会标志*/
          ,application_name                                          /*应用名称*/
          ,opp_industry                                              /*行业（opp)*/
          ,estimated_close_time                                      /*预期关闭时间*/
          ,tag_list                                                  /*标签列表*/
          ,discount_amount                                           /*折扣金额*/
          ,area_id                                                   /*地区编号*/
          ,branch_id                                                 /*分支编号*/
          ,extension_id                                              /*扩展编号*/
          ,legal_company_name                                        /*法定公司名称*/
          ,account_number                                            /*账号编号*/
          ,marketing_program_type                                    /*市场项目类型*/
          ,lead_number                                               /*线索编号*/
          ,crm_contact_number                                        /*联系人编号*/
          ,parent_account_name                                       /*父账号名称*/
          ,Scd_Start_Dt                                              /*开始时间*/
          ,Scd_End_Dt                                                /*结束时间*/
          ,Etl_Batch_No                                              /*作业批次号*/
          ,Etl_First_Dt                                              /*最初入库时间*/
          ,Etl_Job                                                   /*作业名称*/
          ,Etl_Proc_Dt                                               /*本次入库时间*/
          ,Etl_Tx_Dt                                                 /*作业运行时间*/
          ,Src_Sysname                                               /*来源系统*/
          ,Src_Table                                                 /*来源表*/
          ,parent_contact_name                                       /*父联系人名称*/
          ,product_name                                              /*产品名称*/
          ,product_class                                             /*产品类别*/
          ,currency_name                                             /*交易币种*/
 )
SELECT
          P1.tek_opportunity_id                                        /*泰克机会编号*/
         ,P1.uint_price                                                /*单价*/
         ,P1.discount_percent                                          /*折扣率*/
         ,P1.discount_amount_base                                      /*基础折扣金额*/
         ,P1.base_amount                                               /*基础金额*/
         ,P1.total_amount                                              /*总金额*/
         ,P1.sales_funnel_stage                                        /*销售漏斗层级*/
         ,P1.sales_funnel_stage_id                                     /*销售漏斗层级编号*/
         ,P1.status                                                    /*状况*/
         ,P1.state                                                     /*状态*/
         ,P1.region                                                    /*区域*/
         ,P1.opportunity_name                                          /*机会名称*/
         ,P1.acount_manager                                            /*账号经理*/
         ,P1.territory_id                                              /*领域编号*/
         ,P1.forecast_opp_ind                                          /*预期机会标志*/
         ,P1.risk_ind                                                  /*风险标志*/
         ,P1.opportunity_age                                           /*机会年份*/
         ,P1.create_time                                               /*创建时间*/
         ,P1.create_person                                             /*创建人*/
         ,P1.pipline_last_update                                       /*pipline最后更新时间*/
         ,P1.status_last_update                                        /*状况最后更新时间*/
         ,P1.channel_id                                                /*渠道编号*/
         ,P1.tektronix_apname                                          /*tek_tektronixapname*/
         ,P1.purchase_method                                           /*采购方式*/
         ,P1.campaign_name                                             /*活动名称*/
         ,P1.web_medium                                                /*网络媒介*/
         ,P1.web_source                                                /*网络来源*/
         ,P1.customer_app                                              /*客户应用*/
         ,P1.vertical_segment                                          /*垂直领域*/
         ,P1.competitive_status                                        /*竞争状态*/
         ,P1.important_opportunity_ind                                 /*重要机会标志*/
         ,P1.application_name                                          /*应用名称*/
         ,P1.opp_industry                                              /*行业（opp)*/
         ,P1.estimated_close_time                                      /*预期关闭时间*/
         ,P1.tag_list                                                  /*标签列表*/
         ,P1.discount_amount                                           /*折扣金额*/
         ,P1.area_id                                                   /*地区编号*/
         ,P1.branch_id                                                 /*分支编号*/
         ,P1.extension_id                                              /*扩展编号*/
         ,P1.legal_company_name                                        /*法定公司名称*/
         ,P1.account_number                                            /*账号编号*/
         ,P1.marketing_program_type                                    /*市场项目类型*/
         ,P1.lead_number                                               /*线索编号*/
         ,P1.crm_contact_number                                        /*联系人编号*/
         ,P1.parent_account_name                                       /*父账号名称*/
         ,P1.Scd_Start_Dt                                              /*开始时间*/
         ,P1.Scd_End_Dt                                                /*结束时间*/
         ,P1.Etl_Batch_No                                              /*作业批次号*/
         ,P1.Etl_First_Dt                                              /*最初入库时间*/
         ,P1.Etl_Job                                                   /*作业名称*/
         ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
         ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
         ,P1.Src_Sysname                                               /*来源系统*/
         ,P1.Src_Table                                                 /*来源表*/
         ,P1.parent_contact_name                                       /*父联系人名称*/
         ,P1.product_name                                              /*产品名称*/
         ,P1.product_class                                             /*产品类别*/
         ,P1.currency_name                                             /*交易币种*/

FROM  t01_crm_opportunity_agi_INS P1
;


;

;
/*****程序结束退出                                               */
\q

