
DROP TABLE IF EXISTS p20_pdm.t01_udesk_record;
CREATE TABLE IF NOT EXISTS p20_pdm.t01_udesk_record (
	 record_time  timestamp(0) 
	, duration  time 
	, cust  varchar(20) 
	, mobile_phone  varchar(20) 
	, call_result  varchar(20) 
	, call_origin_location  varchar(20) 
	, relay_number  varchar(50) 
	, satisfaction  varchar(20) 
	, type  varchar(20) 
	, device_status  varchar(20) 
	, company_name  varchar(20) 
	, queue_status  varchar(20) 
	, queue_time  time 
	, message  varchar(20) 
	, hung_up  varchar(20) 
	, responsible_group  varchar(20) 
	, blacklist  varchar(20) 
	, inquiry_content  varchar(20) 
	, icr_record  text 
	, call_id  varchar(50) 
	,primary key( record_time,call_id )
);

 COMMENT ON COLUMN p20_pdm.t01_udesk_record.record_time IS '记录时间'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.duration IS '通话时长'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.cust IS '客户'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.mobile_phone IS '客户电话'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.call_result IS '通话结果'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.call_origin_location IS '归属地'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.relay_number IS '中继号'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.satisfaction IS '满意度评价'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.type IS '通话类型'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.device_status IS '设备状态'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.company_name IS '公司'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.queue_status IS '排队状态'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.queue_time IS '排队耗时'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.message IS '留言'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.hung_up IS '通话挂断方'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.responsible_group IS '负责组'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.blacklist IS '是否在黑名单'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.inquiry_content IS '咨询内容'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.icr_record IS 'IVR录音'; 
 COMMENT ON COLUMN p20_pdm.t01_udesk_record.call_id IS 'Call ID'; 

COMMENT ON TABLE p20_pdm.t01_udesk_record IS 'Udesk记录';