/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :d_test(t1)             */
/*Create Date:2024-04-10 14:55:58                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-04-10                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-04-10                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: .v_cust_contact_mapping_all                                                      */
/*Source table 2: .d_scrm_contact                                                                  */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:d_test                                                                              */
/*ETL Job Name:d_test                                                                              */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F1                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE d_test_agi_CUR_I 
 ( LIKE :MARTDB.d_test)
ON COMMIT PRESERVE ROWS;


/*****************************************************************************************************/
/* GROUP 1:Source Table:v_cust_contact_mapping_all****************************************************/
/*****************************************************************************************************/

INSERT INTO d_test_agi_CUR_I (
            contact_id                              /*联系人编号*/
           ,user_id                                 /*联系人联系方式*/
           ,crm_contact                             /*CRM联系*/
           ,scrm_contact                            /*SCRM联系*/
           ,email                                   /*邮箱*/
           ,livechat_contact                        /*Livechat联系*/
           ,udesk_contact                           /*Udesk联系*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(p0.contact_id),'')                          /*contact_id*/
        ,COALESCE(TRIM(p0.user_id),'')                             /*user_id*/
        ,COALESCE(TRIM(p0.crm_contact),'')                         /*crm_contact*/
        ,COALESCE(TRIM(p0.scrm_contact),'')                        /*scrm_contact*/
        ,p1.email                                                  /*email*/
        ,COALESCE(TRIM(p0.livechat_contact),'')                    /*livechat_contact*/
        ,COALESCE(TRIM(p0.udesk_contact),'')                       /*udesk_contact*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('v_cust_contact_mapping_all',1,3)                  /*Src_Sysname*/
        ,'v_cust_contact_mapping_all'                              /*Src_Table*/
        
FROM None.v_cust_contact_mapping_all  p0
LEFT JOIN None
        ON p0.scrm_contact =p1.scrm_leads_id 


;



/*从目标表中删除所有数据 d_test(t1)                                 */
DELETE FROM :MARTDB.d_test 
WHERE ETL_JOB=:ETLJOB;


/*将新增数据插入到目标表                                                                           */
;INSERT INTO :MARTDB.d_test (
             contact_id                                                /*联系人编号*/
            ,user_id                                                   /*联系人联系方式*/
            ,crm_contact                                               /*CRM联系*/
            ,scrm_contact                                              /*SCRM联系*/
            ,email                                                     /*邮箱*/
            ,livechat_contact                                          /*Livechat联系*/
            ,udesk_contact                                             /*Udesk联系*/
            ,Etl_Batch_No                                              /*作业批次号*/
            ,Etl_First_Dt                                              /*最初入库时间*/
            ,Etl_Job                                                   /*作业名称*/
            ,Etl_Proc_Dt                                               /*本次入库时间*/
            ,Etl_Tx_Dt                                                 /*作业运行时间*/
            ,Src_Sysname                                               /*来源系统*/
            ,Src_Table                                                 /*来源表*/
            
    )
    SELECT
             P1.contact_id                                                /*联系人编号*/
            ,P1.user_id                                                   /*联系人联系方式*/
            ,P1.crm_contact                                               /*CRM联系*/
            ,P1.scrm_contact                                              /*SCRM联系*/
            ,P1.email                                                     /*邮箱*/
            ,P1.livechat_contact                                          /*Livechat联系*/
            ,P1.udesk_contact                                             /*Udesk联系*/
            ,P1.Etl_Batch_No                                              /*作业批次号*/
            ,P1.Etl_First_Dt                                              /*最初入库时间*/
            ,P1.Etl_Job                                                   /*作业名称*/
            ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
            ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
            ,P1.Src_Sysname                                               /*来源系统*/
            ,P1.Src_Table                                                 /*来源表*/
            
    FROM d_test_agi_CUR_I P1
 
;
/*****程序结束退出                                               */
\q

