
DROP TABLE IF EXISTS p20_pdm.t00_country_info;
CREATE TABLE IF NOT EXISTS p20_pdm.t00_country_info (
	 country_cn_name  varchar(50) 
	, country_en_name  varchar(50) 
	, country_cd  varchar(10) 
	, country_abbr  varchar(10) 
	, country_number  int 
	, inter_tel_cd  varchar(10) 
	, internet_name  varchar(20) 
	, Etl_Batch_No  varchar(50) 
	, Etl_First_Dt  timestamp(0) 
	, Etl_Job  varchar(50) 
	, Etl_Proc_Dt  timestamp(0) 
	, Etl_Tx_Dt  timestamp(0) 
	, Src_Sysname  varchar(50) 
	, Src_Table  varchar(50) 
	,primary key( country_cd )
);

 COMMENT ON COLUMN p20_pdm.t00_country_info.country_cn_name IS '国家'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.country_en_name IS '国家英文名'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.country_cd IS '国家代码'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.country_abbr IS '国家缩写'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.country_number IS '数字代码'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.inter_tel_cd IS '国际区号'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.internet_name IS '域名'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Etl_Batch_No IS '作业批次号'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Etl_First_Dt IS '最初入库时间'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Etl_Job IS '作业名称'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Etl_Proc_Dt IS '本次入库时间'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Etl_Tx_Dt IS '作业运行时间'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Src_Sysname IS '来源系统'; 
 COMMENT ON COLUMN p20_pdm.t00_country_info.Src_Table IS '来源表'; 

COMMENT ON TABLE p20_pdm.t00_country_info IS '国家信息';